!
! @file fmultilap.F90
!
! Fortran 90 multiple rhs example.
!
! This example tries to solve a problem with multiple matrices and
! rhs. It is possible to use multiple pastix instances to solve the
! problems in parallel, and it is possible to force multiple
! sequential solves in parallel with OpenMP instead of mumti-threaded
! pastix solves.
!
! To launch the testing: ./fmultilap < test_config.in
! with test_config.in of the following format:
!
! ---------------------------------------------------------------
! A single comment line to describe the file
! 1                      Enable/disable the verbose mode
! 0                      Enable/disable the check and correct
! 0                      Enable/disable the multi-threaded solves
! 5                      Total number of threads
! 1                      Number of PaStiX instances
! 2                      Number of outermost iterations
! 2                      Number of distinct matrices per iteration
! 10                     Number of righ-hand-side per matrix
! 2                      Number of solve step per problem
! 10                     First dimension of each laplacian matrix
! 10                     Second dimension of each laplacian matrix
! 10                     Third dimension of each laplacian matrix
! ---------------------------------------------------------------
!
! @copyright 2015-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!                      Univ. Bordeaux. All rights reserved.
!
! @version 6.4.0
! @author Andrea Piacentini
! @author Mathieu Faverge
! @author Alycia Lisito
! @date 2024-07-05
!
#ifndef DOXYGEN_SHOULD_SKIP_THIS

program fmultilap
  use iso_c_binding
  use spmf
  use pastixf

  implicit none

  type multilap_param
     logical                    :: checkmat    ! Enable/disable the check and correct on the spm matrix
     logical                    :: multirhs    ! Enable/disable multi-rhs solves
     logical                    :: output      ! Enable output information
     integer                    :: dim1        ! First dimension of the Laplacian matrix
     integer                    :: dim2        ! Second dimension of the Laplacian matrix
     integer                    :: dim3        ! Third dimension of the Laplacian matrix
     integer(kind=pastix_int_t) :: n           ! Size of the matrix
     integer                    :: nnz         ! Number of non zeroes in the matrix
     integer                    :: nb_outit    ! Number of outer iteration
     integer                    :: nb_mat      ! Number of matrices to factorize per iteration
     integer                    :: nb_rhs      ! Number of right hand side per matrix
     integer                    :: nb_solve    ! Number of solve steps per RHS
     integer                    :: nb_sys      ! Number of systems (each couple composed of 1 matrix with 1 subset of rhs)
     integer                    :: nb_thrd     ! Number of thread available
     integer                    :: nb_fact_omp ! Number of PaStiX instances for the factorization
     integer                    :: nb_fact_thd ! Number of threads per PaStiX instances for the factorization
     integer                    :: nb_solv_omp ! Number of PaStiX instances for the solve
     integer                    :: nb_solv_thd ! Number of threads per PaStiX instances for the solve
  end type multilap_param

  type rhs_subset
     integer(kind=pastix_int_t)                              :: idmat ! Index of the associated matrix
     integer(kind=pastix_int_t)                              :: nrhs  ! Number of RHS in the subset
     complex(kind=c_double_complex), dimension(:,:), pointer :: b0    ! Array of the initial b, to restart at each iteration
     complex(kind=c_double_complex), dimension(:,:), pointer :: b     ! Array of the b vector
     complex(kind=c_double_complex), dimension(:,:), pointer :: x     ! Array of the x vector
     type(pastix_rhs_t)                                      :: bp    ! Structure to hold the permuted b
     type(pastix_rhs_t)                                      :: xp    ! Structure to hold the permuted x
  end type rhs_subset

  type sys_lin
     integer(kind=pastix_int_t)                              :: pid         ! Index of the pastix instance factorizing the matrix
     integer(kind=pastix_int_t)                              :: nsys        ! Number of subsystems used to solve the rhs
     type(pastix_data_t),                            pointer :: pastix_data ! The pastix_data associated to the matrix
     integer(kind=pastix_int_t),     dimension(iparm_size)   :: iparm       ! iparm array associated to the matrix
     real(kind=c_double),            dimension(dparm_size)   :: dparm       ! dparm array associated to the matrix
     type(spmatrix_t),                               pointer :: spm         ! Pointer to the spm matrix
     integer(kind=pastix_int_t),     dimension(:),   pointer :: rowptr      ! User matrix
     integer(kind=pastix_int_t),     dimension(:),   pointer :: colptr      ! User matrix
     complex(kind=c_double_complex), dimension(:),   pointer :: values      ! User matrix
     type(rhs_subset),               dimension(:,:), pointer :: rhs         ! Array of rhs subsets
  end type sys_lin

  type(multilap_param)                              :: params    ! Parameters of the example
  type(sys_lin), dimension(:), allocatable, target  :: sys_array ! Array of all the linear systems to solve
  integer(kind=pastix_int_t), dimension(iparm_size) :: iparm     ! Global iparm array used to initialize the systems
  real(kind=c_double), dimension(dparm_size)        :: dparm     ! Global dparm array used to initialize the systems
  type(sys_lin), pointer                            :: matrix
  type(rhs_subset), pointer                         :: rhs
  integer, dimension(:), allocatable                :: ila_thrmn, ila_thrmx, ila_thrsz
  integer(kind=c_int), dimension(:), pointer        :: bindtab
  integer(kind=pastix_int_t)                        :: th, im, ir, i, j, k
  integer(kind=pastix_int_t)                        :: size
  integer(c_int)                                    :: info, ginfo = 0
  !
  integer, parameter :: MULTILAP_ANALYZE_TIME = 1
  integer, parameter :: MULTILAP_FACT_TIME    = 2
  integer, parameter :: MULTILAP_FACT_FLOPS   = 3
  integer, parameter :: MULTILAP_SOLV_TIME    = 4
  integer, parameter :: MULTILAP_MAX_STAT     = MULTILAP_SOLV_TIME
  !
  real(kind=c_double),  allocatable, dimension(:,:)  :: dla_thread_stats
  real(kind=c_double),  dimension(MULTILAP_MAX_STAT) :: dla_final_stats = 0.0

  !
  ! Get the problem confirguration
  !
  call multilap_init( params )

  !
  ! Set some parameters in iparm
  !
  call pastixInitParam( iparm, dparm )

  iparm(IPARM_THREAD_NBR) = params%nb_fact_thd
  if ( iparm(IPARM_THREAD_NBR) == 1 ) then
     iparm(IPARM_SCHEDULER)  = PastixSchedSequential
  else
     iparm(IPARM_SCHEDULER)  = PastixSchedStatic
  end if
  iparm(IPARM_VERBOSE)       = PastixVerboseNot
  iparm(IPARM_FACTORIZATION) = PastixFactLLT

  ! Initialize the matrices structures
  allocate(sys_array(params%nb_mat))
  do im = 1, params%nb_mat
     !
     matrix => sys_array(im)
     !
     matrix%iparm(:) = iparm(:)
     matrix%dparm(:) = dparm(:)
     !

     ! Initialize the solve structures
     if ( params%multirhs ) then
        !
        ! multi-thread RHS is enabled
        ! Distribute the rhs solve in the same manner as the matrices factorizations
        !
        matrix%nsys = 1
        allocate(matrix%rhs( matrix%nsys, 1 ))

        rhs => matrix%rhs(1,1)
        rhs%nrhs = params%nb_rhs

        size = rhs%nrhs * params%n

        if ( params%output ) then
           ! Allocate a backup of b that will be destroyed by the check
           allocate(rhs%b0(size, 1))
        end if
        allocate(rhs%b(size, 1))
        allocate(rhs%x(size, 1))

     else
        !
        ! multi-thread rhs is disabled
        ! Distribute the rhs solve among each sequential thread issued from the factorization
        !
        call split_parall( params%nb_rhs, params%nb_fact_thd )

        matrix%nsys = iparm(IPARM_THREAD_NBR)
        allocate(matrix%rhs( matrix%nsys, 1 ))

        do th = 1, iparm(IPARM_THREAD_NBR)

           rhs => matrix%rhs(th,1)

           rhs%nrhs = ila_thrsz(th)
           size = rhs%nrhs * params%n

           if ( rhs%nrhs .gt. 0 ) then
              if ( params%output ) then
                 ! Allocate a backup of b that will be destroyed by the check
                 allocate(rhs%b0(size, 1))
              end if
              allocate(rhs%b(size, 1))
              allocate(rhs%x(size, 1))
           end if
        end do
     end if
  end do

  if (params%output) then
     write( 6, * )        '!--------------------------------------------------------------------!'
     write( 6, * )        '     Size of x = ', params%n
     write( 6, fmt=8888 ) 'Matrix', 'NRHS', 'Start', 'End'

     do im = 1, params%nb_mat
        matrix => sys_array(im)
        k = 1
        do j = 1, matrix%nsys
           rhs => matrix%rhs(j,1)
           write( 6, fmt=8889 ) im, rhs%nrhs, k, k + rhs%nrhs - 1
           k = k + rhs%nrhs
        end do
     end do
  end if


  !
  ! Initialization loop to create the PaStiX instances
  !
  call split_parall( params%nb_mat, params%nb_fact_omp )

  !
  !$OMP PARALLEL NUM_THREADS(params%nb_fact_omp) DEFAULT(NONE) &
  !$OMP SHARED(params, sys_array, k)            &
  !$OMP SHARED(ila_thrsz, ila_thrmn, ila_thrmx) &
  !$OMP SHARED(dla_thread_stats, iparm, dparm)  &
  !$OMP PRIVATE(th, im, ir, i, j )              &
  !$OMP PRIVATE(matrix, rhs) &
  !$OMP PRIVATE(info, bindtab)

  !$OMP DO SCHEDULE(STATIC,1)
  init_loop: do th = 1, params%nb_fact_omp
     !
     ! Give each matrix a subset of cores
     !
     allocate( bindtab( iparm(IPARM_THREAD_NBR) ) )
     do i = 1, iparm(IPARM_THREAD_NBR)
        bindtab( i ) = int((th-1) * iparm(IPARM_THREAD_NBR) + (i - 1), c_int)
     end do

     do im = ila_thrmn(th), ila_thrmx(th)

        matrix => sys_array(im)
        matrix%pid = th

        ! 1- Initialize the parameters and the solver
        call pastixInitWithAffinity( matrix%pastix_data, MPI_COMM_WORLD, &
             & matrix%iparm, matrix%dparm, bindtab )

     end do

     deallocate(bindtab)
  end do init_loop
  !$OMP END DO
  !$OMP END PARALLEL

  !
  ! Outmost iteration
  !
  main_loop: do k = 1, params%nb_outit
     !
     write(6,*) '!====================================================================!'
     write(6,*) ' Outer iteration: ', k
     write(6,*) '!--------------------------------------------------------------------!'
     write(6,*) ' Nb of factorization performed in parallel      = ', params%nb_fact_omp
     write(6,*) ' Nb of threads used by PaStiX per factorization = ', params%nb_fact_thd

     !
     ! Distribute factorizations among parallel threads
     !
     call split_parall( params%nb_mat, params%nb_fact_omp )
     !
     allocate(dla_thread_stats(params%nb_mat, MULTILAP_MAX_STAT))
     dla_thread_stats(:,:) = 0.0

     !
     !$OMP PARALLEL NUM_THREADS(params%nb_fact_omp) DEFAULT(NONE) &
     !$OMP SHARED(params, sys_array, k)            &
     !$OMP SHARED(ila_thrsz, ila_thrmn, ila_thrmx) &
     !$OMP SHARED(dla_thread_stats, iparm, dparm)  &
     !$OMP PRIVATE(th, im, ir, i, j )              &
     !$OMP PRIVATE(matrix, rhs)      &
     !$OMP PRIVATE(info, bindtab)

     !$OMP DO SCHEDULE(STATIC,1)
     fact_loop: do th = 1, params%nb_fact_omp
        !
        ! Give each matrix a subset of cores
        !
        do im = ila_thrmn(th), ila_thrmx(th)

           matrix => sys_array(im)

           matrix%pid = th

           ! 0- Generate the SPM matrix
           call multilap_genOneMatrix( params, matrix, k, im )

           ! 2- Analyze the problem
           call pastix_task_analyze( matrix%pastix_data, matrix%spm, info )
           if ( info .ne. 0 ) then
              error stop "pastix_task_analyze failed"
           end if
           dla_thread_stats(th,MULTILAP_ANALYZE_TIME) = &
                & dla_thread_stats(th,MULTILAP_ANALYZE_TIME) + matrix%dparm(DPARM_ANALYZE_TIME)

           ! 3- Factorize the matrix
           call pastix_task_numfact( matrix%pastix_data, matrix%spm, info )
           if ( info .ne. 0 ) then
              error stop "pastix_task_numfact failed"
           end if

           dla_thread_stats(th,MULTILAP_FACT_TIME) = &
                & dla_thread_stats(th,MULTILAP_FACT_TIME) + matrix%dparm(DPARM_FACT_TIME)
           dla_thread_stats(th,MULTILAP_FACT_FLOPS) = &
                & dla_thread_stats(th,MULTILAP_FACT_FLOPS) + (matrix%dparm(DPARM_FACT_FLOPS)/(1024.0**3))

        end do

     end do fact_loop
     !$OMP END DO
     !$OMP END PARALLEL

     if ( params%output ) then
        write(6,*) '!--------------------------------------------------------------------!'
        write(6,*) '! Results per matrix'
        write(6,*) '!'
        do im = 1, params%nb_mat
           matrix => sys_array(im)

           write(6,*) ' Matrix ', im, ' done by instance ', matrix%pid
           write(6,*) ' Time for analysis      ', matrix%dparm(DPARM_ANALYZE_TIME)
           write(6,*) ' Pred Time for fact     ', matrix%dparm(DPARM_PRED_FACT_TIME)
           write(6,*) ' Time for factorization ', matrix%dparm(DPARM_FACT_TIME)
           write(6,*) ' GFlops/s for fact      ', matrix%dparm(DPARM_FACT_FLOPS)/(1024.0**3)
        end do

        write(6,*) '!--------------------------------------------------------------------!'
        write(6,*) '! Results per PaStiX instance'
        write(6,*) '!'
        do th = 1, params%nb_fact_omp
           dla_thread_stats(th,MULTILAP_FACT_FLOPS) = &
                & dla_thread_stats(th,MULTILAP_FACT_FLOPS) / ila_thrsz(th)
           write(6,*) ' Thread ',th
           write(6,*) ' Time for analysis      ', dla_thread_stats(th,MULTILAP_ANALYZE_TIME)
           write(6,*) ' Time for factorization ', dla_thread_stats(th,MULTILAP_FACT_TIME)
           write(6,*) ' GFlops/s for fact      ', dla_thread_stats(th,MULTILAP_FACT_FLOPS)
        end do

        write(6,*) '!--------------------------------------------------------------------!'
        write(6,*) ' Outer iterate ', k
        write(6,*) ' Time for analysis      ', maxval(dla_thread_stats(:,MULTILAP_ANALYZE_TIME))
        write(6,*) ' Time for factorization ', maxval(dla_thread_stats(:,MULTILAP_FACT_TIME))
        write(6,*) ' GFlops/s for fact      ', sum(dla_thread_stats(:,MULTILAP_FACT_FLOPS)) / params%nb_fact_omp
     end if

     dla_final_stats(MULTILAP_ANALYZE_TIME) = dla_final_stats(MULTILAP_ANALYZE_TIME) + &
          & maxval(dla_thread_stats(:,MULTILAP_ANALYZE_TIME))
     dla_final_stats(MULTILAP_FACT_TIME) = dla_final_stats(MULTILAP_FACT_TIME) + &
          & maxval(dla_thread_stats(:,MULTILAP_FACT_TIME))
     dla_final_stats(MULTILAP_FACT_FLOPS) = dla_final_stats(MULTILAP_FACT_FLOPS) + &
          & (sum(dla_thread_stats(:,MULTILAP_FACT_FLOPS)) / params%nb_fact_omp)
     !
     deallocate(dla_thread_stats)

     !
     ! Distribute solves among parallel threads
     !
     allocate(dla_thread_stats( params%nb_solv_omp, MULTILAP_MAX_STAT ))
     dla_thread_stats(:,:) = 0.0

     write(6,*) '!--------------------------------------------------------------------!'
     write(6,*) ' Nb of OpenMP threads enrolled for solution      = ', params%nb_solv_omp
     write(6,*) ' Nb of pthreads used in PaStiX for solution      = ', params%nb_solv_thd

     call split_parall( params%nb_sys, params%nb_solv_omp )

     do i = 1, params%nb_solve

        write(6,*) '!--------------------------------------------------------------------!'
        write(6,*) ' Solve iteration nr. ', i

        !
        !$OMP PARALLEL NUM_THREADS(params%nb_solv_omp) DEFAULT(NONE) &
        !$OMP SHARED(params, sys_array, k, i)         &
        !$OMP SHARED(ila_thrsz, ila_thrmn, ila_thrmx) &
        !$OMP SHARED(dla_thread_stats, iparm, dparm)  &
        !$OMP PRIVATE(th, im, ir, j )                 &
        !$OMP PRIVATE(matrix, rhs) &
        !$OMP PRIVATE(info)

        !$OMP DO SCHEDULE(STATIC,1)
        solve_loop: do th = 1, params%nb_solv_omp
           solve_loop2: do j = ila_thrmn(th), ila_thrmx(th)

              if ( params%multirhs ) then
                 im = j
                 ir = 1
              else
                 im = ((j-1) / params%nb_fact_thd) + 1
                 ir = mod( j-1, params%nb_fact_thd ) + 1
              end if
              matrix => sys_array(im)
              rhs    => matrix%rhs( ir, 1 )

              if ( .not. (rhs%nrhs .gt. 0)) then
                 cycle
              endif

              !   2- The right hand side
              if (i==1) then
                 call spmGenRHS( SpmRhsRndX, rhs%nrhs, matrix%spm, &
                      & B=rhs%b, ldb=params%n, info=info )
                 if ( info .ne. 0 ) then
                    error stop "spmGenRHS failed"
                 end if

                 if ( params%output ) then
                    ! Backup initial b that will be overwritten by check
                    rhs%b0(:,:) = rhs%b(:,:)
                 end if
              else
                 if ( params%output ) then
                    ! Restore the initial b overwritten by check
                    rhs%b(:,:) = rhs%b0(:,:)
                 end if
              end if

              ! Set the sequential scheduler to enable multiple solves in parallel with the same matrix
              if ( .not. params%multirhs ) then
                 matrix%iparm(IPARM_SCHEDULER) = PastixSchedSequential
              end if

              ! 3- Permute the b pointer
              rhs%x(:,:) = rhs%b(:,:)
              call pastixRhsInit( rhs%bp, info )
              if ( info .ne. 0 ) then
                 error stop "pastixRhsInit bp failed"
              end if
              call pastix_subtask_applyorder( matrix%pastix_data, PastixDirForward, &
                   &                          matrix%spm%nexp, rhs%nrhs, rhs%b, matrix%spm%nexp, rhs%bp, info )
              if ( info .ne. 0 ) then
                 error stop "pastix_subtask_applyorder bp failed"
              end if
              call pastixRhsInit( rhs%xp, info )
              if ( info .ne. 0 ) then
                 error stop "pastixRhsInit xp failed"
              end if
              call pastix_subtask_applyorder( matrix%pastix_data, PastixDirForward, &
                   &                          matrix%spm%nexp, rhs%nrhs, rhs%x, matrix%spm%nexp, rhs%xp, info )
              if ( info .ne. 0 ) then
                 error stop "pastix_subtask_applyorder rp failed"
              end if

              ! 4- Solve the problem
              call pastix_subtask_solve( matrix%pastix_data, rhs%xp, info )
              if ( info .ne. 0 ) then
                 error stop "pastix_subtask_solve failed"
              end if

              dla_thread_stats(th, MULTILAP_SOLV_TIME) =  &
                   & dla_thread_stats(th,MULTILAP_SOLV_TIME) + matrix%dparm(DPARM_SOLV_TIME)

              ! 5- Refine the solution
              call pastix_subtask_refine( matrix%pastix_data, rhs%bp, rhs%xp, info )
              if ( info .ne. 0 ) then
                 error stop "pastix_subtask_refine failed"
              end if

              ! 6- Apply the backward permutation on b and x
              call pastix_subtask_applyorder( matrix%pastix_data, PastixDirBackward, &
                   &                          matrix%spm%nexp, rhs%nrhs, rhs%b, matrix%spm%nexp, rhs%bp, info )
              if ( info .ne. 0 ) then
                 error stop "pastix_subtask_applyorder b failed"
              end if

              call pastixRhsFinalize( rhs%bp, info )
              if ( info .ne. 0 ) then
                 error stop "pastixRhsFinalize b failed"
              end if

              call pastix_subtask_applyorder( matrix%pastix_data, PastixDirBackward, &
                   &                          matrix%spm%nexp, rhs%nrhs, rhs%x, matrix%spm%nexp, rhs%xp, info )
              if ( info .ne. 0 ) then
                 error stop "pastix_subtask_applyorder x failed"
              end if

              call pastixRhsfinalize( rhs%xp, info )
              if ( info .ne. 0 ) then
                 error stop "pastixRhsFinalize x failed"
              end if

           end do solve_loop2
        end do solve_loop
        !$OMP END DO
        !$OMP END PARALLEL

        ! Restore the initial scheduler
        if ( .not. params%multirhs ) then
           do im = 1, params%nb_mat
              matrix => sys_array(im)
              matrix%iparm(IPARM_SCHEDULER) = iparm(IPARM_SCHEDULER)
           end do
        end if

        if (params%output) then
           do th = 1, params%nb_solv_omp
              do j = ila_thrmn(th), ila_thrmx(th)

                 if ( params%multirhs ) then
                    im = j
                    ir = 1
                 else
                    im = ((j-1) / params%nb_fact_thd) + 1
                    ir = mod( j-1, params%nb_fact_thd ) + 1
                 end if
                 matrix => sys_array(im)
                 rhs    => matrix%rhs( ir, 1 )

                 if ( .not. (rhs%nrhs .gt. 0)) then
                    cycle
                 endif

                 write(6,*) '!--------------------------------------------------------------------!'
                 write(6,*) ' Check results for system ', im, ir

                 !
                 ! Check the solution
                 !
                 call spmPrintInfo( matrix%spm )

                 call spmCheckAxb( matrix%dparm(DPARM_EPSILON_REFINEMENT), rhs%nrhs, &
                      & matrix%spm,    &
                      & B=rhs%b, ldb=matrix%spm%nexp, &
                      & X=rhs%x, ldx=matrix%spm%nexp, info=info )
                 if ( info .ne. 0 ) then
                    error stop "spmCheckAxb failed"
                 end if

                 ginfo = ginfo + info
              end do
           end do

           write(6,*) '!--------------------------------------------------------------------!'
           do th = 1, params%nb_fact_omp
              write(6,*) ' Thread ', th
              write(6,*) ' Time for solution      ', dla_thread_stats(th,MULTILAP_SOLV_TIME)
           end do
        end if
     end do ! End of iteration loop

     if (params%output) then
        write(6,*) '!--------------------------------------------------------------------!'
        write(6,*) ' Outer iterate ', k
        write(6,*) ' Time for solution      ', maxval(dla_thread_stats(:,MULTILAP_SOLV_TIME))
     end if

     dla_final_stats(MULTILAP_SOLV_TIME) = dla_final_stats(MULTILAP_SOLV_TIME) + &
          & maxval(dla_thread_stats(:,MULTILAP_SOLV_TIME))

     deallocate(dla_thread_stats)

     ! Free memory
     do im=1, params%nb_mat
        matrix => sys_array(im)
        ! 6- Destroy the C data structure
        call spmExit( matrix%spm )
        deallocate( matrix%spm )
     end do
  end do main_loop

  ! Destroy the matrices structures
  do im = 1, params%nb_mat
     !
     matrix => sys_array(im)

     call pastixFinalize( matrix%pastix_data )

     do ir = 1, matrix%nsys
        rhs => matrix%rhs(ir, 1)

        if ( rhs%nrhs .gt. 0 ) then
           if ( params%output ) then
              ! Allocate a backup of b that will be destroyed by the check
              deallocate(rhs%b0)
           end if
           deallocate(rhs%b)
           deallocate(rhs%x)
        end if
     end do
     deallocate( matrix%rhs )
  end do

  deallocate(sys_array)
  if (allocated(ila_thrsz)) deallocate(ila_thrsz)
  if (allocated(ila_thrmn)) deallocate(ila_thrmn)
  if (allocated(ila_thrmx)) deallocate(ila_thrmx)

  write(6,*) '!====================================================================!'

  write(6,*) ' Overall final statistics'
  write(6,*) ' Time for analysis      ', dla_final_stats(MULTILAP_ANALYZE_TIME)
  write(6,*) ' Time for factorization ', dla_final_stats(MULTILAP_FACT_TIME)
  write(6,*) ' GFlops/s for fact      ', dla_final_stats(MULTILAP_FACT_FLOPS) / params%nb_outit
  write(6,*) ' Time for solution      ', dla_final_stats(MULTILAP_SOLV_TIME)
  write(6,*) '!====================================================================!'

  call exit(ginfo)

8888 format( '  ', A6, ' ', A6, ' ', A6, ' ', A6 )
8889 format( '  ', I6, ' ', I6, ' ', I6, ' ', I6 )

contains

  !
  ! @brief Initialize the testing parameters based on the input configuration file
  !
  ! @param[output] params
  !
  subroutine multilap_init( params )
    type(multilap_param), intent(out), target :: params
    integer                                   :: val, dim1, dim2, dim3

    ! Read a dummy line.
    read( 5, * )

    ! Read if we enable/disable the verbose mode
    read( 5, * ) val
    params%output = .not. ( val .eq. 0 )

    ! Read if we enable/disable the check and correct
    read( 5, * ) val
    params%checkmat = .not. ( val .eq. 0 )

    ! Read if we enable/disable the multi-threaded solve
    read( 5, * ) val
    params%multirhs = .not. ( val .eq. 0 )

    ! Read the total number of threads
    read( 5, * ) params%nb_thrd

    if( params%nb_thrd < 1 ) then
       write( 6, fmt = 9999 ) 'nb_thrd', params%nb_thrd, params%nb_thrd, 1
       call exit(1)
    end if

    ! Read the number of pastix instances
    read( 5, * ) params%nb_fact_omp

    if( params%nb_fact_omp .lt. 1 ) then
       write( 6, fmt = 9999 ) 'nb_fact_omp', params%nb_fact_omp, 1
       call exit(1)
    else if( params%nb_fact_omp .gt. params%nb_thrd) then
       write( 6, fmt = 9998 ) 'nb_fact_omp', params%nb_fact_omp, params%nb_thrd
       call exit(1)
    endif

    params%nb_fact_thd = params%nb_thrd / params%nb_fact_omp
    if ( (params%nb_fact_thd * params%nb_fact_omp) .ne. params%nb_thrd ) then
       write( 6, * ) 'nb_thrd (', params%nb_thrd, ')must be a multiple of nb_pastix (', params%nb_fact_omp, ')'
       call exit(1)
    end if

    ! Read the number of outer most iterations
    read( 5, * ) params%nb_outit

    if( params%nb_outit .lt. 1 ) then
       write( 6, fmt = 9999 ) 'nb_outit', params%nb_outit, 1
       call exit(1)
    end if

    ! Read the number of matrices to factorize
    read( 5, * ) params%nb_mat

    if( params%nb_mat .lt. params%nb_fact_omp ) then
       write( 6, fmt = 9999 ) 'nb_mat', params%nb_mat, params%nb_fact_omp
       call exit(1)
    endif

    ! Read the number of RHS per iteration
    read( 5, * ) params%nb_rhs

    if( params%nb_rhs .lt. 1 ) then
       write( 6, fmt = 9999 ) 'nb_rhs', params%nb_rhs, 1
       call exit(1)
    end if

    ! Read the number of solve per iteration
    read( 5, * ) params%nb_solve

    if( params%nb_solve .lt. 1 ) then
       write( 6, fmt = 9999 ) 'nb_solve', params%nb_solve, 1
       call exit(1)
    end if

    ! Read the dimensions of the laplacian
    read( 5, * ) dim1

    if( dim1 .lt. 1 ) then
       write( 6, fmt = 9999 ) 'dim1', dim1, 1
       call exit(1)
    end if

    read( 5, * ) dim2

    if( dim2 .lt. 1 ) then
       write( 6, fmt = 9999 ) 'dim2', dim2, 1
       call exit(1)
    end if

    read( 5, * ) dim3

    if( dim3 .lt. 1 ) then
       write( 6, fmt = 9999 ) 'dim3', dim3, 1
       call exit(1)
    end if

    if ( params%multirhs ) then
       params%nb_sys      = params%nb_mat
       params%nb_solv_omp = params%nb_fact_omp
       params%nb_solv_thd = params%nb_fact_thd
    else
       params%nb_sys      = params%nb_mat * params%nb_fact_thd
       params%nb_solv_omp = params%nb_thrd
       params%nb_solv_thd = 1
    endif

    params%dim1 = dim1
    params%dim2 = dim2
    params%dim3 = dim3
    params%n    = dim1 * dim2 * dim3
    params%nnz  = (2*(dim1)-1) * dim2 * dim3 + (dim2-1)*dim1*dim3 + dim2*dim1*(dim3-1)

    write(6,*) '!--------------------------------------------------------------------!'
    write(6,*) '!           Multiple Laplacian testing configuration                 !'
    write(6,*) '!--------------------------------------------------------------------!'
    write(6,*) ' Nb of threads                               = ', params%nb_thrd
    write(6,*) ' Nb of PaStiX instances                      = ', params%nb_fact_omp
    write(6,*) ' Nb of outer iterations                      = ', params%nb_outit
    write(6,*) ' Nb of distinct matrices                     = ', params%nb_mat
    write(6,*) ' Nb of RHS to solve per matrix               = ', params%nb_rhs
    write(6,*) ' Nb of solve phase to perform per RHS        = ', params%nb_solve
    write(6,*) ' Size of each matrix                         = ', params%n, &
         &     '(', dim1, ' x ', dim2, ' x ', dim3, ')'
    write(6,*) ' Nbr of non zero entries per matrix          = ', params%nnz

    if ( params%multirhs ) then
       write(6,*) ' The multirhs mode is enabled'
    else
       write(6,*) ' The multirhs mode is disabled'
    endif

9998 format( ' Invalid input value: ', A8, '=', I6, '; must be <=', I6 )
9999 format( ' Invalid input value: ', A8, '=', I6, '; must be >=', I6 )

  end subroutine multilap_init

  !
  ! Generate a single laplacian spm matrix with the parameters stores
  ! in the matrix description
  !
  subroutine multilap_genOneMatrix( params, matrix, ib_out, ib )
    type(multilap_param),       intent(in),    target :: params
    type(sys_lin),              intent(inout), target :: matrix
    integer(kind=pastix_int_t), intent(in)            :: ib, ib_out
    integer(kind=pastix_int_t)                        :: dim1, dim2, dim3
    integer(kind=pastix_int_t)                        :: i, j, k, l
    type(spmatrix_t), pointer                         :: spm2

    !
    ! Laplacian dimensions
    !
    dim1 = params%dim1
    dim2 = params%dim2
    dim3 = params%dim3

    !
    ! Create the spm out of the internal data
    !
    allocate( matrix%spm )
    call spmInit( matrix%spm )
    matrix%spm%baseval = 1
    matrix%spm%mtxtype = SpmHermitian
    matrix%spm%flttype = SpmComplex64
    matrix%spm%fmttype = SpmIJV
    matrix%spm%n       = params%n
    matrix%spm%nnz     = params%nnz
    matrix%spm%dof     = 1

    call spmUpdateComputedFields( matrix%spm )
    call spmAlloc( matrix%spm )

    call spmGetArray( matrix%spm,  &
         colptr  = matrix%colptr, &
         rowptr  = matrix%rowptr, &
         zvalues = matrix%values )

    l = 1
    do i=1,dim1
       do j=1,dim2
          do k=1,dim3
             matrix%rowptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
             matrix%colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
             matrix%values(l) = (6., 0.)

             if (i == 1) then
                matrix%values(l) = matrix%values(l) - (1., 0.)
             end if
             if (i == dim1) then
                matrix%values(l) = matrix%values(l) - (1., 0.)
             end if
             if (j == 1) then
                matrix%values(l) = matrix%values(l) - (1., 0.)
             end if
             if (j == dim2) then
                matrix%values(l) = matrix%values(l) - (1., 0.)
             end if
             if (k == 1) then
                matrix%values(l) = matrix%values(l) - (1., 0.)
             end if
             if (k == dim3) then
                matrix%values(l) = matrix%values(l) - (1., 0.)
             end if

             matrix%values(l) = matrix%values(l) * 8.
             l = l + 1

             if (i < dim1) then
                matrix%rowptr(l) =  i    + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
                matrix%colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
                matrix%values(l) = -(1., 0.)
                l = l + 1
             end if
             if (j < dim2) then
                matrix%rowptr(l) = (i-1) + dim1 *  j    + dim1 * dim2 * (k-1) + 1
                matrix%colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
                matrix%values(l) = -(1., 0.)
                l = l + 1
             end if
             if (k < dim3) then
                matrix%rowptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 *  k    + 1
                matrix%colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
                matrix%values(l) = -(1., 0.)
                l = l + 1
             end if
          end do
       end do
    end do

    matrix%values(:) = matrix%values(:)*(dble(ib) * dble(ib_out) / 4.0)

    if (params%checkmat) then
       allocate( spm2 )
       call spmCheckAndCorrect( matrix%spm, spm2, info )
       if ( info .ne. 0 ) then
          call spmExit( matrix%spm )
          matrix%spm = spm2
       end if
       deallocate( spm2 )
    else
       call spmConvert( SpmCSC, matrix%spm, info )
    endif
  end subroutine multilap_genOneMatrix

  !
  subroutine split_parall(id_size, id_thr)

    integer, intent(in) :: id_size
    integer, intent(in) :: id_thr

    if (allocated(ila_thrsz)) deallocate(ila_thrsz)
    allocate(ila_thrsz(id_thr))
    if (allocated(ila_thrmn)) deallocate(ila_thrmn)
    allocate(ila_thrmn(id_thr))
    if (allocated(ila_thrmx)) deallocate(ila_thrmx)
    allocate(ila_thrmx(id_thr))

    ila_thrsz(:) = id_size / id_thr
    ila_thrsz(1:id_size-id_thr*ila_thrsz(1)) =&
         &  ila_thrsz(1:id_size-id_thr*ila_thrsz(1)) + 1

    ila_thrmn(1) = 1
    do i = 1, id_thr-1
       ila_thrmx(i)   = ila_thrmn(i) + ila_thrsz(i)-1
       ila_thrmn(i+1) = ila_thrmx(i) + 1
    end do
    ila_thrmx(id_thr) = id_size

  end subroutine split_parall

end program fmultilap

#endif

!>
!> @file spmf_user.F90
!>
!> @brief Fortran 90 example where the user provides its own matrix in IJV format
!>
!> Fortran 90 example using a laplacian matrix.
!>
!> @copyright 2015-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!>                      Univ. Bordeaux. All rights reserved.
!>
!> @version 1.2.4
!> @author Mathieu Faverge
!> @author Alycia Lisito
!> @date 2024-05-29
!>
!> @ingroup examples_fortran
!>
#ifndef DOXYGEN_SHOULD_SKIP_THIS
program spmf_user
  use iso_c_binding
  use spmf
#if defined(SPM_WITH_MPI)
  use mpi_f08
#endif
  implicit none

  integer(kind=spm_int_t), dimension(:), pointer               :: rowptr
  integer(kind=spm_int_t), dimension(:), pointer               :: colptr
  real(kind=c_double),     dimension(:), pointer               :: values
  real(kind=c_double),     dimension(:,:), allocatable, target :: x0, x, b
  real(kind=c_double)                                          :: eps = 1.e-15
  type(spmatrix_t),        target                              :: spm
  integer(kind=spm_int_t)                                      :: dim1, dim2, dim3, n, nnz
  integer(kind=spm_int_t)                                      :: i, j, k, l, nrhs
  integer(c_int)                                               :: info

#if defined(SPM_WITH_MPI)
  ! SPM is compiled with MPI, thus MPI must be initialized
  ! before any spm call
  call MPI_Init( info )
#endif

  !
  ! Generate a 10x10x10 complex Laplacian in IJV format
  !
  dim1 = 10
  dim2 = 10
  dim3 = 10
  n    = dim1 * dim2 * dim3
  nnz  = (2*(dim1)-1) * dim2 * dim3 + (dim2-1)*dim1*dim3 + dim2*dim1*(dim3-1)

  !
  ! Create the spm out of the internal data
  !
  call spmInit( spm )
  spm%baseval = 1
  spm%mtxtype = SpmSymmetric
  spm%flttype = SpmDouble
  spm%fmttype = SpmIJV
  spm%n       = n
  spm%nnz     = nnz
  spm%dof     = 1

  call spmUpdateComputedFields( spm )
  call spmAlloc( spm )

  call spmGetArray( spm, colptr=colptr, rowptr=rowptr, dvalues=values )

  l = 1
  do i=1,dim1
     do j=1,dim2
        do k=1,dim3
           rowptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
           colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
           values(l) = 6.

           if (i == 1) then
              values(l) = values(l) - 1.
           end if
           if (i == dim1) then
              values(l) = values(l) - 1.
           end if
           if (j == 1) then
              values(l) = values(l) - 1.
           end if
           if (j == dim2) then
              values(l) = values(l) - 1.
           end if
           if (k == 1) then
              values(l) = values(l) - 1.
           end if
           if (k == dim3) then
              values(l) = values(l) - 1.
           end if

           values(l) = values(l) * 8.
           l = l + 1

           if (i < dim1) then
              rowptr(l) =  i    + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
              colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
              values(l) = - 1.
              l = l + 1
           end if
           if (j < dim2) then
              rowptr(l) = (i-1) + dim1 *  j    + dim1 * dim2 * (k-1) + 1
              colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
              values(l) = - 1.
              l = l + 1
           end if
           if (k < dim3) then
              rowptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 *  k    + 1
              colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
              values(l) = -1.
              l = l + 1
           end if
        end do
     end do
  end do

  if ( l .ne. nnz+1 ) then
     write(6,*) 'l ', l, " nnz ", nnz
  end if

  call spmPrintInfo( spm )

  !   2- The right hand side
  nrhs = 10
  allocate(x0(spm%nexp, nrhs))
  allocate(x( spm%nexp, nrhs))
  allocate(b( spm%nexp, nrhs))

  ! Compute b = A * x, with x random
  call spmGenRHS( SpmRhsRndX, nrhs, spm, x0, spm%nexp, b, spm%nexp, info )

  ! Copy x0 into x
  x = x0

  !
  ! Check the solution
  !
  call spmCheckAxb( eps, nrhs, spm, x0, spm%nexp, b, spm%nexp, x, spm%nexp, info )

  call spmExit( spm )
  deallocate(x0)
  deallocate(x)
  deallocate(b)

#if defined(SPM_WITH_MPI)
  call MPI_Finalize( info )
#endif

end program spmf_user

#endif

#=

 @file PaStiX.jl

 PaStiX julia wrapper

 @copyright 2020-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                      Univ. Bordeaux. All rights reserved.

 @version 6.4.0
 @author Mathieu Faverge
 @author Selmane Lebdaoui
 @author Tony Delarue
 @date 2024-06-08

 This file has been automatically generated with gen_wrappers.py

 @ingroup wrap_julia

=#

module PaStiX
using CBinding
using Libdl
include("pastix_enums.jl")

function pastix_library_path()
    x = Libdl.dlext
    return "libpastix.$x"
end
libpastix = pastix_library_path()

@cbindings libpastix begin
    @cextern pastixOrderInit( ordeptr::Ptr{Pastix_order_t}, baseval::Pastix_int_t, vertnbr::Pastix_int_t, cblknbr::Pastix_int_t, perm::Ptr{Pastix_int_t}, invp::Ptr{Pastix_int_t}, rang::Ptr{Pastix_int_t}, tree::Ptr{Pastix_int_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastixOrderAlloc( ordeptr::Ptr{Pastix_order_t}, vertnbr::Pastix_int_t, cblknbr::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixOrderAllocId( ordeptr::Ptr{Pastix_order_t}, vertnbr::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixOrderExit( ordeptr::Ptr{Pastix_order_t} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixOrderBase( ordeptr::Ptr{Pastix_order_t}, baseval::Pastix_int_t )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixOrderCheck( ordeptr::Ptr{Pastix_order_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastixOrderCopy( ordedst::Ptr{Pastix_order_t}, ordesrc::Ptr{Pastix_order_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastixOrderGet( pastix_data::Ptr{Pastix_data_t} )::Ptr{Pastix_order_t}
end

@cbindings libpastix begin
    @cextern pastixOrderBcast( ordemesh::Ptr{Pastix_order_t}, root::Cint, pastix_comm::__get_mpi_type__() )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixOrderGrid( myorder::Ptr{Cvoid}, nx::Pastix_int_t, ny::Pastix_int_t, nz::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixOrderLoad( pastix_data::Ptr{Pastix_data_t}, ordeptr::Ptr{Pastix_order_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastixOrderSave( pastix_data::Ptr{Pastix_data_t}, ordeptr::Ptr{Pastix_order_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix( pastix_data::Ptr{Cvoid}, pastix_comm::__get_mpi_type__(), n::Pastix_int_t, colptr::Ptr{Pastix_int_t}, rowptr::Ptr{Pastix_int_t}, values::Ptr{Cvoid}, perm::Ptr{Pastix_int_t}, invp::Ptr{Pastix_int_t}, B::Ptr{Cvoid}, nrhs::Pastix_int_t, iparm::Ptr{Pastix_int_t}, dparm::Ptr{Cdouble} )::Cint
end

@cbindings libpastix begin
    @cextern pastixInitParam( iparm::Ptr{Pastix_int_t}, dparm::Ptr{Cdouble} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixInit( pastix_data::Ptr{Cvoid}, pastix_comm::__get_mpi_type__(), iparm::Ptr{Pastix_int_t}, dparm::Ptr{Cdouble} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixInitWithAffinity( pastix_data::Ptr{Cvoid}, pastix_comm::__get_mpi_type__(), iparm::Ptr{Pastix_int_t}, dparm::Ptr{Cdouble}, bindtab::Ptr{Cint} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixFinalize( pastix_data::Ptr{Cvoid} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastix_task_analyze( pastix_data::Ptr{Pastix_data_t}, spm::Ptr{spm.spmatrix_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_task_numfact( pastix_data::Ptr{Pastix_data_t}, spm::Ptr{spm.spmatrix_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_task_solve( pastix_data::Ptr{Pastix_data_t}, m::Pastix_int_t, nrhs::Pastix_int_t, B::Ptr{Cvoid}, ldb::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastix_task_refine( pastix_data::Ptr{Pastix_data_t}, n::Pastix_int_t, nrhs::Pastix_int_t, B::Ptr{Cvoid}, ldb::Pastix_int_t, X::Ptr{Cvoid}, ldx::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastix_task_solve_and_refine( pastix_data::Ptr{Pastix_data_t}, n::Pastix_int_t, nrhs::Pastix_int_t, B::Ptr{Cvoid}, ldb::Pastix_int_t, X::Ptr{Cvoid}, ldx::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_order( pastix_data::Ptr{Pastix_data_t}, spm::Ptr{spm.spmatrix_t}, myorder::Ptr{Pastix_order_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_symbfact( pastix_data::Ptr{Pastix_data_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_reordering( pastix_data::Ptr{Pastix_data_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_blend( pastix_data::Ptr{Pastix_data_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_spm2bcsc( pastix_data::Ptr{Pastix_data_t}, spm::Ptr{spm.spmatrix_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_bcsc2ctab( pastix_data::Ptr{Pastix_data_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_sopalin( pastix_data::Ptr{Pastix_data_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_applyorder( pastix_data::Ptr{Pastix_data_t}, dir::spm.spm_dir_t, m::Pastix_int_t, n::Pastix_int_t, B::Ptr{Cvoid}, ldb::Pastix_int_t, Bp::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_trsm( pastix_data::Ptr{Pastix_data_t}, side::Cint, uplo::Cint, trans::Pastix_trans_t, diag::Pastix_diag_t, b::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_diag( pastix_data::Ptr{Pastix_data_t}, b::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_solve( pastix_data::Ptr{Pastix_data_t}, b::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_refine( pastix_data::Ptr{Pastix_data_t}, b::Pastix_rhs_t, x::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastix_subtask_solve_adv( pastix_data::Ptr{Pastix_data_t}, transA::Pastix_trans_t, b::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixIsolateUnknowns( pastix_data::Ptr{Pastix_data_t}, n::Pastix_int_t, list::Ptr{Pastix_int_t} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixSetSchurUnknownList( pastix_data::Ptr{Pastix_data_t}, n::Pastix_int_t, list::Ptr{Pastix_int_t} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixGetSchur( pastix_data::Ptr{Pastix_data_t}, S::Ptr{Cvoid}, lds::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixRhsInit( rhs::Ptr{Pastix_rhs_t} )::Cint
end

@cbindings libpastix begin
    @cextern pastixRhsFinalize( rhs::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixRhsDoubletoSingle( dB::Pastix_rhs_t, sB::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixRhsSingleToDouble( sB::Pastix_rhs_t, dB::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixRhsSchurGet( pastix_data::Ptr{Pastix_data_t}, m::Pastix_int_t, n::Pastix_int_t, rhsB::Pastix_rhs_t, B::Ptr{Cvoid}, ldb::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixRhsSchurSet( pastix_data::Ptr{Pastix_data_t}, m::Pastix_int_t, n::Pastix_int_t, B::Ptr{Cvoid}, ldb::Pastix_int_t, rhsB::Pastix_rhs_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixExpand( pastix_data::Ptr{Pastix_data_t}, spm::Ptr{spm.spmatrix_t} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixGetDiag( pastix_data::Ptr{Pastix_data_t}, x::Ptr{Cvoid}, incx::Pastix_int_t )::Cint
end

@cbindings libpastix begin
    @cextern pastixGetOptions( argc::Cint, argv::Ptr{Cvoid}, iparm::Ptr{Pastix_int_t}, dparm::Ptr{Cdouble}, check::Ptr{Cint}, scatter::Ptr{Cint}, driver::Ptr{spm.spm_driver_t}, filename::Ptr{Cvoid} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixDumpParam( pastix_data::Ptr{Pastix_data_t} )::Cvoid
end

@cbindings libpastix begin
    @cextern pastixCheckParam( iparm::Ptr{Pastix_int_t}, dparm::Ptr{Cdouble} )::Cint
end

@cbindings libpastix begin
    @cextern pastixBlasGetNumThreads(  )::Cint
end

@cbindings libpastix begin
    @cextern pastixBlasSetNumThreads( nt::Cint )::Cint
end

@cbindings libpastix begin
    @cextern pastixBlasSetNumThreadsOne(  )::Cint
end

end #module

#=

 @file spm_enums.jl

 SPM julia wrapper to define enums and datatypes

 @copyright 2020-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                      Univ. Bordeaux. All rights reserved.

 @version 1.2.4
 @author Mathieu Faverge
 @author Selmane Lebdaoui
 @author Tony Delarue
 @date 2024-06-27

 This file has been automatically generated with gen_wrappers.py

 @ingroup wrap_julia

=#

const spm_int_t = Int32
const spm_mpi_enabled = true

if spm_mpi_enabled
    using MPI
end

function __get_mpi_type__()
    if !spm_mpi_enabled
        return Cint
    elseif sizeof(MPI.MPI_Comm) == sizeof(Clong)
        return Clong
    elseif sizeof(MPI.MPI_Comm) == sizeof(Cint)
        return Cint
    end
    return Cvoid
end

@cenum spm_verbose_t {
    SpmNot = 0,
    SpmNo  = 1,
    SpmYes = 2,
}

@cenum spm_coeftype_t {
    SpmPattern   = 0,
    SpmFloat     = 2,
    SpmDouble    = 3,
    SpmComplex32 = 4,
    SpmComplex64 = 5,
}

@cenum spm_fmttype_t {
    SpmCSC = 0,
    SpmCSR = 1,
    SpmIJV = 2,
}

@cenum spm_error_t {
    SPM_SUCCESS            = 0,
    SPM_ERR_UNKNOWN        = 1,
    SPM_ERR_ALLOC          = 2,
    SPM_ERR_NOTIMPLEMENTED = 3,
    SPM_ERR_OUTOFMEMORY    = 4,
    SPM_ERR_THREAD         = 5,
    SPM_ERR_INTERNAL       = 6,
    SPM_ERR_BADPARAMETER   = 7,
    SPM_ERR_FILE           = 8,
    SPM_ERR_INTEGER_TYPE   = 9,
    SPM_ERR_IO             = 10,
    SPM_ERR_MPI            = 11,
}

@cenum spm_driver_t {
    SpmDriverRSA        = 0,
    SpmDriverHB         = 1,
    SpmDriverIJV        = 2,
    SpmDriverMM         = 3,
    SpmDriverLaplacian  = 4,
    SpmDriverXLaplacian = 5,
    SpmDriverGraph      = 6,
    SpmDriverSPM        = 7,
}

@cenum spm_rhstype_t {
    SpmRhsOne  = 0,
    SpmRhsI    = 1,
    SpmRhsRndX = 2,
    SpmRhsRndB = 3,
}

@cenum spm_layout_t {
    SpmRowMajor = 101,
    SpmColMajor = 102,
}

@cenum spm_trans_t {
    SpmNoTrans   = 111,
    SpmTrans     = 112,
    SpmConjTrans = 113,
}

@cenum spm_mtxtype_t {
    SpmGeneral   = SpmNoTrans,
    SpmSymmetric = SpmTrans,
    SpmHermitian = SpmConjTrans,
}

@cenum spm_uplo_t {
    SpmUpper      = 121,
    SpmLower      = 122,
    SpmUpperLower = 123,
}

@cenum spm_diag_t {
    SpmNonUnit = 131,
    SpmUnit    = 132,
}

@cenum spm_side_t {
    SpmLeft  = 141,
    SpmRight = 142,
}

@cenum spm_normtype_t {
    SpmOneNorm       = 171,
    SpmFrobeniusNorm = 174,
    SpmInfNorm       = 175,
    SpmMaxNorm       = 177,
}

@cenum spm_dir_t {
    SpmDirForward  = 391,
    SpmDirBackward = 392,
}

@cstruct spmatrix_t {
    mtxtype::spm_mtxtype_t
    flttype::spm_coeftype_t
    fmttype::spm_fmttype_t
    baseval::spm_int_t
    gN::spm_int_t
    n::spm_int_t
    gnnz::spm_int_t
    nnz::spm_int_t
    gNexp::spm_int_t
    nexp::spm_int_t
    gnnzexp::spm_int_t
    nnzexp::spm_int_t
    dof::spm_int_t
    dofs::Ptr{spm_int_t}
    layout::spm_layout_t
    colptr::Ptr{spm_int_t}
    rowptr::Ptr{spm_int_t}
    loc2glob::Ptr{spm_int_t}
    values::Ptr{Cvoid}
    glob2loc::Ptr{spm_int_t}
    clustnum::Cint
    clustnbr::Cint
    comm::__get_mpi_type__()
    replicated::Cint
}

!>
!> @file spmf_rebalance.F90
!>
!> @brief Fortran 90 internal testing to check gather/Scatter fortran
!> interface.
!>
!> It basically gather a non balanced distributed spm, and
!> re-distribute it in a balanced way.
!>
!> @copyright 2017-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!>                      Univ. Bordeaux. All rights reserved.
!>
!> @version 1.2.4
!> @author Mathieu Faverge
!> @author Alycia Lisito
!> @date 2024-05-29
!>
!> @ingroup examples_fortran
!>
#ifndef DOXYGEN_SHOULD_SKIP_THIS
program spmf_rebalance
  use iso_c_binding
  use spmf
#if defined(SPM_WITH_MPI)
  use mpi_f08
#endif
  implicit none

  type(spmatrix_t), target :: spm
  type(spmatrix_t), target :: spml
  type(spmatrix_t), target :: spmg
  integer(c_int)           :: info
  integer(spm_int_t)       :: n
  integer                  :: rank = 0
  integer                  :: size = 1

#if defined(SPM_WITH_MPI)
  ! SPM is compiled with MPI, thus MPI must be initialized
  ! before any spm call
  call MPI_Init( info )
  call MPI_Comm_rank( MPI_COMM_WORLD, rank )
  call MPI_Comm_size( MPI_COMM_WORLD, size )
#endif

  !
  ! Initialize the problem
  !   1- The matrix
  call spmReadDriverDist( SpmDriverLaplacian, "d:10:10:10:4.", spm, MPI_COMM_WORLD, info )
  call spmPrintInfo( spm )

  n = spm%gN / size

  if ( rank .eq. 0 ) then
     call spmGather( spm, 0, spmg )
     call spmPrintInfo( spmg )
  else
     call spmGather( spm, 0 )
  end if

  call spmExit( spm )

  if ( rank .eq. 0 ) then
     n = n + mod( spm%gN, size )
     call spmScatter( spml, 0, spmg )
     call spmExit( spmg )
  else
     call spmScatter( spml, 0 )
  end if

  call spmPrintInfo( spml )
  call spmExit( spml )

#if defined(SPM_WITH_MPI)
  call MPI_Finalize( info )
#endif

end program spmf_rebalance

#endif

!
! @file fsimple.F90
!
! Fortran 90 example using a matrix read with the spm driver.
!
! @copyright 2017-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!                      Univ. Bordeaux. All rights reserved.
!
! @version 6.4.0
! @author Mathieu Faverge
! @author Alycia Lisito
! @date 2024-07-05
!
program fsimple
  use iso_c_binding
  use spmf
  use pastixf

  implicit none

  type(pastix_data_t),        pointer                      :: pastix_data
  type(spmatrix_t),           pointer                      :: spm
  type(spmatrix_t),           pointer                      :: spm2
  integer(kind=pastix_int_t), target                       :: iparm(iparm_size)
  real(kind=c_double),        target                       :: dparm(dparm_size)
  real(kind=c_double)                                      :: normA
  integer(c_int)                                           :: info
  integer(kind=pastix_int_t)                               :: nrhs
  real(kind=c_double), dimension(:,:), allocatable, target :: x0, x, b

  !
  ! Solve the problem
  !

  ! 1- Initialize the parameters and the solver
  call pastixInitParam( iparm, dparm )
  call pastixInit( pastix_data, MPI_COMM_WORLD, iparm, dparm )

  !
  ! Initialize the problem
  !   1- The matrix
  allocate( spm )
  call spmReadDriver( SpmDriverLaplacian, "d:10:10:10:2.", spm, info )
  if ( info .ne. 0 ) then
     error stop "spmReadDriver failed"
  end if

  allocate( spm2 )
  call spmCheckAndCorrect( spm, spm2, info )
  if ( info .ne. 0 ) then
     call spmExit( spm )
     spm = spm2
  end if
  deallocate( spm2 )

  call spmPrintInfo( spm )

  ! Scale A for better stability with low-rank computations
  call spmNorm( SpmFrobeniusNorm, spm, normA )
  call spmScal( 1. / normA, spm )

  !   2- The right hand side
  nrhs = 10
  allocate(x0(spm%nexp, nrhs))
  allocate(x( spm%nexp, nrhs))
  allocate(b( spm%nexp, nrhs))

  call spmGenRHS( SpmRhsRndX, nrhs, spm, x0, spm%nexp, b, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "spmGenRHS failed"
  end if
  x = b

  ! 2- Analyze the problem
  call pastix_task_analyze( pastix_data, spm, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_analyze failed"
  end if

  ! 3- Factorize the matrix
  call pastix_task_numfact( pastix_data, spm, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_numfact failed"
  end if

  ! 4- Solve the problem
  call pastix_task_solve( pastix_data, spm%nexp, nrhs, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_solve failed"
  end if

  ! 5- Refine the solution
  call pastix_task_refine( pastix_data, spm%nexp, nrhs, b, spm%nexp, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_refine failed"
  end if

  ! 6- Destroy the C data structure
  call pastixFinalize( pastix_data )

  !
  ! Check the solution
  !
  call spmCheckAxb( dparm(DPARM_EPSILON_REFINEMENT), nrhs, spm, x0, spm%nexp, b, spm%nexp, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "spmCheckAxb failed"
  end if

  call spmExit( spm )
  deallocate(spm)
  deallocate(x0)
  deallocate(x)
  deallocate(b)

end program fsimple

!>
!> @file spmf_driver.F90
!>
!> @brief Fortran 90 example using a matrix read with the spm driver.
!>
!> @copyright 2017-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!>                      Univ. Bordeaux. All rights reserved.
!>
!> @version 1.2.4
!> @author Mathieu Faverge
!> @author Alycia Lisito
!> @date 2024-05-29
!>
!> @ingroup examples_fortran
!>
#ifndef DOXYGEN_SHOULD_SKIP_THIS
program spmf_driver
  use iso_c_binding
  use spmf
#if defined(SPM_WITH_MPI)
  use mpi_f08
#endif
  implicit none

  type(spmatrix_t),           target                       :: spm
  real(kind=c_double)                                      :: normA
  real(kind=c_double)                                      :: eps = 1.e-15
  integer(c_int)                                           :: info
  integer(kind=spm_int_t)                                  :: nrhs
  real(kind=c_double), dimension(:,:), allocatable, target :: x0, x, b

#if defined(SPM_WITH_MPI)
  ! SPM is compiled with MPI, thus MPI must be initialized
  ! before any spm call
  call MPI_Init( info )
#endif

  !
  ! Initialize the problem
  !   1- The matrix
  call spmReadDriver( SpmDriverLaplacian, "d:10:10:10:4.", spm, info )
  call spmPrintInfo( spm )

  ! Scale A for better stability with low-rank computations
  call spmNorm( SpmFrobeniusNorm, spm, normA )
  call spmScal( 1. / normA, spm )

  !   2- The right hand side
  nrhs = 10
  allocate(x0(spm%nexp, nrhs))
  allocate(x( spm%nexp, nrhs))
  allocate(b( spm%nexp, nrhs))

  ! Compute b = A * x, with x random
  call spmGenRHS( SpmRhsRndX, nrhs, spm, x0, spm%nexp, b, spm%nexp, info )

  ! Copy x0 into x
  x = x0

  !
  ! Check the solution
  !
  call spmCheckAxb( eps, nrhs, spm, x0, spm%nexp, b, spm%nexp, x, spm%nexp, info )

  call spmExit( spm )
  deallocate(x0)
  deallocate(x)
  deallocate(b)

#if defined(SPM_WITH_MPI)
  call MPI_Finalize( info )
#endif

end program spmf_driver

#endif

#!/usr/bin/env julia
#=
 @file examples/step-by-step.jl

 PaStiX step by step example

 @copyright 2019-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                      Univ. Bordeaux. All rights reserved.

 @version 6.4.0
 @author Mathieu Faverge
 @author Selmane Lebdaoui
 @date 2024-07-05
=#

using Pkg
Pkg.activate("../../spm/wrappers/julia/spm")
Pkg.activate("PaStiX")
using CBinding
using PaStiX
using spm
using Printf

if PaStiX.pastix_mpi_enabled
    using MPI
    MPI.Init()
end

#
# Two solutions to select the outpu file to pass to output functions
#
my_stdout = Libc.FILE( Libc.RawFD(1), "w" ) # Select the stdout or stderr through 1 or 2
#my_stdout = Ptr{Cvoid}(0)                   # Give a null pointer to use the default

# Initialize parameters to default values
iparm = zeros( PaStiX.Pastix_int_t, PaStiX.iparm_size )
dparm = zeros( Cdouble, PaStiX.dparm_size )
PaStiX.pastixInitParam( iparm, dparm )

iparm[PaStiX.iparm_scheduler] = PaStiX.schedsequential # ./simple -s 0

# Startup PaStiX
pastix_data = zeros(Int64,1)
pastix_data_ptr = pointer_from_objref(pastix_data)
PaStiX.pastixInit( pastix_data_ptr, 0, iparm, dparm )

for nsbp in 1:3
    A    = spm.spmatrix_t( zero )
    Aptr = pointer_from_objref( A )

    # Load a sparse matrix
    filename = @sprintf( "%d:%d:%d:4.:1.", nsbp * 5, nsbp * 5, nsbp * 5 )
    spm.spmReadDriver( spm.SpmDriverLaplacian, filename, Aptr )
    spm.spmPrintInfo( Aptr, my_stdout )

    # Scale A for low-rank: A / ||A||_f
    norm = spm.spmNorm( spm.SpmFrobeniusNorm, Aptr )
    spm.spmScal( 1. / norm, Aptr )

    # Perform analyze
    PaStiX.pastix_task_analyze( pastix_data, Aptr )

    for nfact in 1:3
        # Perform numerical factorization
        PaStiX.pastix_task_numfact( pastix_data, Aptr )

        for nsolv in 1:3
            # Generate b and x0 vector such that A * x0 = b
            nrhs = 10
            n    = A.nexp
            X    = zeros(Cdouble, (n, nrhs))
            B    = zeros(Cdouble, (n, nrhs))
            X0   = zeros(Cdouble, (n, nrhs))

            # Generate b and x0 vector such that A * x0 = b
            spm.spmGenRHS( spm.SpmRhsRndX, nrhs, Aptr, X0, n, B, n )

            # Perform solve
            X = copy(B)
            PaStiX.pastix_task_solve( pastix_data, n, nrhs, X, n )

            # Refine the solution
            PaStiX.pastix_task_refine( pastix_data, n, nrhs, B, n, X, n )

            # Check solution
            eps = dparm[PaStiX.dparm_epsilon_refinement]
            spm.spmCheckAxb( eps, nrhs, Aptr, X0, n, B, n, X, n )
        end
    end

    spm.spmExit( Aptr )
end

PaStiX.pastixFinalize( pastix_data_ptr )

!
! @file fstep-by-step.F90
!
! Fortran 90 example using a matrix read with the spm driver.
!
! @copyright 2017-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!                      Univ. Bordeaux. All rights reserved.
!
! @version 6.4.0
! @author Mathieu Faverge
! @author Alycia Lisito
! @date 2024-07-05
!
program fstep_by_step
  use iso_c_binding
  use spmf
  use pastixf
  ! use mpi_f08
  implicit none

  type(pastix_data_t),        pointer                      :: pastix_data
  type(pastix_order_t),       pointer                      :: order => null()
  type(spmatrix_t),           pointer                      :: spm
  type(spmatrix_t),           pointer                      :: spm2
  integer(kind=pastix_int_t), target                       :: iparm(iparm_size)
  real(kind=c_double),        target                       :: dparm(dparm_size)
  integer(c_int)                                           :: info
  integer(kind=pastix_int_t)                               :: nrhs
  real(kind=c_double), dimension(:,:), allocatable, target :: x0, x, b
  integer(kind=pastix_int_t), dimension(:), pointer        :: permtab
  integer                                                  :: i, j, nfact, nsolv

  nfact = 2
  nsolv = 3

  ! 1- Initialize the parameters and the solver
  call pastixInitParam( iparm, dparm )
  call pastixInit( pastix_data, MPI_COMM_WORLD, iparm, dparm )

  !
  ! Initialize the problem
  !   1- The matrix
  allocate( spm )
  call spmReadDriver( SpmDriverLaplacian, "d:10:10:10:2.", spm, info )
  if ( info .ne. 0 ) then
     error stop "spmReadDriver failed"
  end if

  allocate( spm2 )
  call spmCheckAndCorrect( spm, spm2, info )
  if ( info .ne. 0 ) then
     call spmExit( spm )
     spm = spm2
  end if
  deallocate( spm2 )

  call spmPrintInfo( spm )

  !   2- The right hand side
  nrhs = 10
  allocate(x0(spm%nexp,nrhs))
  allocate(x( spm%nexp,nrhs))
  allocate(b( spm%nexp,nrhs))

  ! 2- Perform ordering, symbolic factorization, and analyze steps
  call pastix_subtask_order( pastix_data, spm, order, info )
  if ( info .ne. 0 ) then
     error stop "pastix_subtask_order failed"
  end if

  call pastix_subtask_symbfact( pastix_data, info )
  if ( info .ne. 0 ) then
     error stop "pastix_subtask_symbfact failed"
  end if

  call pastix_subtask_reordering( pastix_data, info )
  if ( info .ne. 0 ) then
     error stop "pastix_subtask_reordering failed"
  end if

  call pastix_subtask_blend( pastix_data, info )
  if ( info .ne. 0 ) then
     error stop "pastix_subtask_blend failed"
  end if

  ! If needed, get the generated ordering
  call pastixOrderGet( pastix_data, order )

  ! Convert the permtab to Fortran array
  call pastixOrderGetArray( order, permtab=permtab )
  print *, permtab(1:10)

  ! 3- Factorize nfact times the matrix
  do i=0,nfact
     ! Perform the numerical factorization
     call pastix_subtask_spm2bcsc( pastix_data, spm, info )
     if ( info .ne. 0 ) then
        error stop "pastix_subtask_spm2bcsc failed"
     end if

     call pastix_subtask_bcsc2ctab( pastix_data, info )
     if ( info .ne. 0 ) then
        error stop "pastix_subtask_bcsc2ctab failed"
     end if

     call pastix_subtask_sopalin( pastix_data, info )
     if ( info .ne. 0 ) then
        error stop "pastix_subtask_sopalin failed"
     end if

     ! Perform nsolv solve steps
     do j=0,nsolv

        call spmGenRHS( SpmRhsRndX, nrhs, spm, x0, spm%nexp, b, spm%nexp, info )
        if ( info .ne. 0 ) then
           error stop "spmGenRHS failed"
        end if
        x = b

        ! 4- Solve the problem
        call pastix_task_solve( pastix_data, spm%nexp, nrhs, x, spm%nexp, info )
        if ( info .ne. 0 ) then
           error stop "pastix_task_solve failed"
        end if

        ! 5- Refine the solution
        call pastix_task_refine( pastix_data, spm%nexp, nrhs, b, spm%nexp, x, spm%nexp, info )
        if ( info .ne. 0 ) then
           error stop "pastix_task_refine failed"
        end if

        ! Check the solution
        call spmCheckAxb( dparm(DPARM_EPSILON_REFINEMENT), nrhs, spm, x0, spm%nexp, b, spm%nexp, x, spm%nexp, info )
        if ( info .ne. 0 ) then
           error stop "spmCheckAxb failed"
        end if

     end do
  end do

  ! 6- Destroy the C data structure
  call pastixFinalize( pastix_data )

  call spmExit( spm )
  deallocate( spm )
  deallocate(x0)
  deallocate(x)
  deallocate(b)

end program fstep_by_step

!
! @file fusermat_csr.F90
!
! Fortran 90 example with a matrix defined by the user matrix.
! Additionaly, this example shows how to cheat with the solver to
! provide a CSR matrix without paying the cost of transposing it.
!
! @copyright 2017-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!                      Univ. Bordeaux. All rights reserved.
!
! @version 6.4.0
! @author Mathieu Faverge
! @author Tony Delarue
! @date 2024-07-05
!
program fusermat_csr
  use iso_c_binding
  use spmf
  use pastixf
#if defined(PASTIX_WITH_MPI)
  use mpi_f08
#endif
  implicit none

  type userMatCSR
     integer                                               :: n        ! Number of vertices
     integer                                               :: nnz      ! Number of non-zeroes in the graph
     integer(kind=pastix_int_t), dimension(:), allocatable :: rows     ! Array of size n+1 of indirections to rows for each vertex
     integer(kind=pastix_int_t), dimension(:), allocatable :: cols     ! Array of size nnz that corresponds to the global column numbering
     integer(kind=pastix_int_t), dimension(:), allocatable :: loc2glob ! Corresponding numbering from local to global
     real(kind=c_double),        dimension(:), allocatable :: vals     ! Values stored in the matrix
  end type userMatCSR

  type(pastix_data_t), pointer                      :: pastix_data

  type(userMatCSR),    pointer :: userMat  ! Local format of the matrix
  type(spmatrix_t),    pointer :: spm      ! Spm format of the matrix

  integer(kind=pastix_int_t), target                       :: iparm(IPARM_SIZE)
  real(kind=c_double),        target                       :: dparm(DPARM_SIZE)
  real(kind=c_double)                                      :: normA
  integer(c_int)                                           :: info
  integer(kind=pastix_int_t)                               :: nrhs
  real(kind=c_double), dimension(:,:), allocatable, target :: x, b

  logical,             parameter :: use_trans = .TRUE.
  real(kind=c_double), parameter :: alpha     = 10.
  real(kind=c_double), parameter :: beta      = 0.5

  !
  ! Solve the problem
  !

  ! 1- Initialize the parameters and the solver
  ! (Done before any calls to spm to automatically intialize MPI if needed)
  call pastixInitParam( iparm, dparm )

  ! Here you can decide to change the parameters from the defaults ones.
  ! A set of IPARM is listed below
  ! All the IPARM are listed here : https://solverstack.gitlabpages.inria.fr/pastix/group__pastix__api.html

  ! Verbose mode - Default: PastixVerboseNo
  ! Possible values : PastixVerboseNot, PastixVerboseNo, PastixVerboseYes
  iparm(IPARM_VERBOSE) = PastixVerboseNo

  ! Factorization mode - Default: PastixFactLU
  ! Possible values : PastixFactLLH, PastixFactLDLT, PastixFactLU, PastixFactLLT, PastixFactLDLH
  iparm(IPARM_FACTORIZATION) = PastixFactLU

  ! Refinement mode - Default: PastixRefineGMRES
  ! Possible values : PastixRefineGMRES, PastixRefineCG, PastixRefineSR, PastixRefineBiCGSTAB
  iparm(IPARM_REFINEMENT) = PastixRefineGMRES

  ! Scheduler mode - Default: PastixSchedDynamic
  ! Possible values : PastixSchedSequential, PastixSchedStatic, PastixSchedParsec, PastixSchedStarpu, PastixSchedDynamic
  iparm(IPARM_SCHEDULER) = PastixSchedDynamic

  call pastixInit( pastix_data, MPI_COMM_WORLD, iparm, dparm )

  ! Initialize the problem
  call create3DLaplacianMatrix( userMat, 4, 4, 4, alpha, beta )

  ! convert the internal matrix format to csc (see other examples to generate directly in the spm format)
  if ( use_trans ) then
     call convert2spmNoCopy( userMat, spm )
     iparm(IPARM_TRANSPOSE_SOLVE) = PastixTrans
  else
     call convert2spmCopy( userMat, spm )
     call cleanUserMat( userMat ) ! Can be done as soon as it is converted if we don't need it
  end if

  ! Scale A for better stability with low-rank computations
  call spmNorm( SpmFrobeniusNorm, spm, normA )
  call spmScal( 1. / normA, spm )

  ! 2- Analyze the problem
  call pastix_task_analyze( pastix_data, spm, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_analyze failed"
  end if

  ! 3- Factorize the matrix
  call pastix_task_numfact( pastix_data, spm, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_numfact failed"
  end if

  !   2- Generate 10 random right hand side
  !
  ! Here since the degree of freedom is 1, n and nexp are equal and
  ! can both be used, but it is a better practice to use nexp if
  ! dof changes
  !
  nrhs = 2
  allocate(x(spm%nexp, nrhs))
  allocate(b(spm%nexp, nrhs))

  call spmGenRHS( SpmRhsRndB, nrhs, spm, B=b, ldb=spm%nexp, info=info )
  if ( info .ne. 0 ) then
     error stop "spmGenRHS failed"
  end if
  x = b

  ! 4- Solve the problem
  call pastix_task_solve( pastix_data, spm%nexp, nrhs, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_solve failed"
  end if

  ! 5- Refine the solution if needed (More optimized version of solver+refinement is presented in fmultilap.F90)
  call pastix_task_refine( pastix_data, spm%nexp, nrhs, b, spm%nexp, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "pastix_rask_refine failed"
  end if

  !
  ! Check the solution
  !
  call spmCheckAxb( dparm(DPARM_EPSILON_REFINEMENT), nrhs, spm, &
       B=b, ldb=spm%nexp, X=x, ldx=spm%nexp, info=info )
  if ( info .ne. 0 ) then
     error stop "spmCheckAxB failed"
  end if

  ! Set fortran pointers to null before calling spmExit()
  call cleanSpm( spm, use_trans )
  if ( use_trans ) then
     call cleanUserMat( userMat ) ! Can be done as soon as it is converted if we don't need it
  end if

  deallocate(x)
  deallocate(b)

  ! 6- Destroy the C data structure (Should be last if used to call MPI_Finalize)
  call pastixFinalize( pastix_data )

contains

  !
  ! This routines creates a random sparse matrix with n vertices, and
  ! nnz non-zeroes. The values are set to corresponds to a Laplacian
  ! with alpha times the degree on the diagonal, and -beta on the edges.
  !
  subroutine create3DLaplacianMatrix( userMat, dim1, dim2, dim3, alpha, beta )

    implicit none

    ! Parameters
    type(userMatCSR),    intent(inout), pointer :: userMat
    integer,             intent(in)             :: dim1, dim2, dim3
    real(kind=c_double), intent(in)             :: alpha, beta

    ! Variables
    integer :: comm_rank, comm_size
    integer :: n, nnz
    integer :: ldim1, k1, k2
    integer :: i, j, k, l, di, dj, dk ! degrees on each dimension

    !
    ! Compute the local number of unknowns by spliting along the
    ! first dimension of the 3D grid if distributed
    !
#if defined(PASTIX_WITH_MPI)
    integer :: ierr
    CALL MPI_COMM_RANK(MPI_COMM_WORLD, comm_rank, ierr)
    CALL MPI_COMM_SIZE(MPI_COMM_WORLD, comm_size, ierr)
#else
    comm_rank = 0
    comm_size = 1
#endif
    ldim1 = dim1 / comm_size;
    k1 = ldim1 *  comm_rank    + 1;
    k2 = ldim1 * (comm_rank+1);

    if (comm_rank < modulo( dim1, comm_size )) then
       k1 = k1 + comm_rank
       k2 = k2 + comm_rank
    end if
    if ((comm_rank+1) < modulo( dim1, comm_size )) then
       k2    = k2 + 1
       ldim1 = ldim1 + 1
    end if

    n = ldim1 * dim2 * dim3

    !
    ! Compute the local number of edges without forgetting the edges
    ! to connect to the neighbors
    !
    nnz = n ! Diagonal elements

    ! Add the beta edges - Sides of the squares
    nnz = nnz + (ldim1 - 1) *  dim2 * dim3;
    nnz = nnz + ( dim2 - 1) * ldim1 * dim3;
    nnz = nnz + ( dim3 - 1) * ldim1 * dim2;

    ! Add connexion edges
    if (comm_rank < min( dim1-1, comm_size-1 )) then
       nnz = nnz + dim2 * dim3
    end if

    ! Initialize the userMat structure
    allocate(userMat)
    userMat%n   = n
    userMat%nnz = nnz
    allocate( userMat%rows( n+1 ) )
    allocate( userMat%cols( nnz ) )
    allocate( userMat%vals( nnz ) )
    if (comm_size > 1) then
       allocate( userMat%loc2glob( n ) )
    end if

    ! Now let's build the matrix with the last dimension first
    n   = 1
    nnz = 1
    userMat%rows(n) = 1
    do i=1,dim3
       di = 0

       ! +1 after the first layer
       if ( i > 1 ) then
          di = di + 1;
       end if

       ! -1 on the last layer
       if ( i < dim3 ) then
          di = di + 1;
       end if

       do j=1,dim2
          dj = 0

          ! +1 after the first layer
          if ( j > 1 ) then
             dj = dj + 1;
          end if

          ! -1 on the last layer
          if ( j < dim2 ) then
             dj = dj + 1;
          end if

          l = (i-1) * dim1 * dim2 + (j-1) * dim1
          do k=k1,k2
             dk = 0

             ! +1 after the first layer
             if ( k > 1 ) then
                dk = dk + 1;
             end if

             ! -1 on the last layer
             if ( k < dim1 ) then
                dk = dk + 1;
             end if

             userMat%rows(n+1) = userMat%rows(n)
             if (comm_size > 1) then
                userMat%loc2glob( n ) = l + k
             end if

             ! Diagonal element
             userMat%rows( n+1 ) = userMat%rows( n+1 ) + 1
             userMat%cols( nnz ) = l + k
             userMat%vals( nnz ) = (di + dk + dj) * alpha;
             nnz = nnz + 1

             ! Connexion along dimension 1
             if ( k < dim1 ) then
                userMat%rows( n+1 ) = userMat%rows( n+1 ) + 1
                userMat%cols( nnz ) = l + k + 1
                userMat%vals( nnz ) = beta;
                nnz = nnz + 1
             end if

             ! Connexion along dimension 2
             if ( j < dim2 ) then
                userMat%rows( n+1 ) = userMat%rows( n+1 ) + 1
                userMat%cols( nnz ) = l + k + dim1
                userMat%vals( nnz ) = beta;
                nnz = nnz + 1
             end if

             ! Connexion along dimension 3
             if ( i < dim3 ) then
                userMat%rows( n+1 ) = userMat%rows( n+1 ) + 1
                userMat%cols( nnz ) = l + k + dim1 * dim2
                userMat%vals( nnz ) = beta;
                nnz = nnz + 1
             end if

             n = n + 1

          end do
       end do
    end do

  end subroutine create3DLaplacianMatrix

  ! Example using fortran allocated arrays
  ! If you are looking for a version with the arrays allocated
  ! thanks to the spm library, please refer to flaplacian.F90
  !
  subroutine convert2spmNoCopy( userMat, spm )
    implicit none

    ! Parameters
    type(userMatCSR), intent(inout), pointer :: userMat
    type(spmatrix_t), intent(out),   pointer :: spm

    allocate( spm )
    call spmInitDist( spm, MPI_COMM_WORLD )
    !
    ! Note that we cheat and use the symmetric property of the
    ! matrix to set it as CSC and avoid incorrrect pointers
    ! management bewteen C and Fortran, so we don't have to call
    ! check and correct that may deallocate fortran pointers.
    !
    spm%baseval = 1              ! Arrays are initialized 1-based
    spm%mtxtype = SpmSymmetric   ! Only one triangle of the matrix is given
    spm%flttype = SpmDouble      ! Values are stores in double
    spm%fmttype = SpmCSC         ! Format in CSC
    spm%n       = userMat%n      ! Local number of unknowns
    spm%nnz     = userMat%nnz    ! Local number of non zeroes
    spm%dof     = 1              ! Degree of freedom per unknown

    spm%colptr = c_loc( userMat%rows )
    spm%rowptr = c_loc( userMat%cols )
    spm%values = c_loc( userMat%vals )

    if (allocated( userMat%loc2glob )) then ! or if MPI_Comm_Size > 1
       spm%replicated = 0 ! Each node owns a portion of the matrix
       spm%loc2glob = c_loc( userMat%loc2glob )
    else
       spm%replicated = 1 ! The matrix is fully replicated on each node (or a single node is used)
    end if

    ! Compute the global information within the structure between the nodes involved
    call spmUpdateComputedFields( spm )

    ! We are sure that the matrix is correct, so we don't call
    ! CheckAndCorrect to not create C/Fortran conflict on the arrays:
    !
    !  - Using CSC format
    !  - No duplicated entries
    !  - entries for all diagonal values
    !

    ! Print basic information for debug
    call spmPrintInfo( spm )
  end subroutine convert2spmNoCopy

  ! Example using fortran allocated arrays
  ! If you are looking for a version with the arrays allocated
  ! thanks to the spm library, please refer to flaplacian.F90
  !
  subroutine convert2spmCopy( userMat, spm )
    implicit none

    ! Parameters
    type(userMatCSR), intent(inout), pointer :: userMat
    type(spmatrix_t), intent(out),   pointer :: spm

    ! Variables
    type(spmatrix_t),                      pointer :: spm2
    integer(kind=spm_int_t), dimension(:), pointer :: rowptr
    integer(kind=spm_int_t), dimension(:), pointer :: colptr
    real(kind=c_double),     dimension(:), pointer :: values
    integer(kind=spm_int_t), dimension(:), pointer :: loc2glob

    allocate( spm )
    call spmInit( spm )        ! By default using MPI_COMM_WORLD, switch to spmInitDist to select the communicator
    spm%baseval = 1            ! Arrays are initialized 1-based
    spm%mtxtype = SpmSymmetric ! Only one triangle of the matrix is given
    spm%flttype = SpmDouble    ! Values are stores in double
    spm%fmttype = SpmCSR       ! Format in CSC
    spm%n       = userMat%n    ! Local number of unknowns
    spm%nnz     = userMat%nnz  ! Local number of non zeroes
    spm%dof     = 1            ! Degree of freedom per unknown

    if (allocated( userMat%loc2glob )) then ! or if MPI_Comm_Size > 1
       spm%replicated = 0 ! Each node owns a portion of the matrix
    else
       spm%replicated = 1 ! The matrix is fully replicated on each node (or a single node is used)
    end if

    ! Compute the global information within the structure between the nodes involved
    call spmUpdateComputedFields( spm )

    call spmAlloc( spm ) ! Allocate the arrays through C calls

    ! get the arrays pointers in fortran
    call spmGetArray( spm, colptr=colptr, rowptr=rowptr, dvalues=values )

    colptr(:) = userMat%cols(:)
    rowptr(:) = userMat%rows(:)
    values(:) = userMat%vals(:)

    if (allocated( userMat%loc2glob )) then ! or if MPI_Comm_Size > 1
       call spmGetArray( spm, loc2glob = loc2glob )
       loc2glob(:) = userMat%loc2glob(:)
    end if

    ! We make sure that the matrix is correct
    !
    !  - Using CSC format
    !  - No duplicated entries
    !  - entries for all diagonal values
    !
    ! WARNING: this call can be costly in time and memory as it may
    ! double the memory to work on the matrix and it goes through
    ! all edges to check the correctness of the spm, thus being
    ! quite slow. If it can be avoided, it should.
    !
    ! When the matrix is correct and the only issue is the CSR
    ! storage, refer so siple_trans.c to solve the transpose
    ! problem.
    !
    allocate( spm2 )
    call spmCheckAndCorrect( spm, spm2, info )
    if ( info .ne. 0 ) then
       call spmExit( spm )
       spm = spm2
    end if
    deallocate( spm2 )

    ! Print basic information for debug
    call spmPrintInfo( spm )
  end subroutine convert2spmCopy

  subroutine cleanUserMat( userMat )
    implicit none

    type(userMatCSR), intent(inout), pointer :: userMat

    deallocate( userMat%cols )
    deallocate( userMat%rows )
    deallocate( userMat%vals )

    if (allocated( userMat%loc2glob )) then ! or if MPI_Comm_Size > 1
       deallocate( userMat%loc2glob )
    end if

    deallocate( userMat )
  end subroutine cleanUserMat

  subroutine cleanSpm( spm, fpointers )
    implicit none

    type(spmatrix_t), intent(inout), pointer :: spm
    logical,          intent(in)             :: fpointers

    if ( fpointers ) then
       spm%colptr = c_null_ptr
       spm%rowptr = c_null_ptr
       spm%values = c_null_ptr
       spm%loc2glob = c_null_ptr
    end if
    call spmExit( spm )
    deallocate(spm)

  end subroutine cleanSpm

end program fusermat_csr

#!/usr/bin/env julia
#=
 @file examples/simple.jl

 PaStiX simple example

 @copyright 2019-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                      Univ. Bordeaux. All rights reserved.

 @version 6.4.0
 @author Mathieu Faverge
 @author Selmane Lebdaoui
 @date 2024-07-05
=#

using Pkg
Pkg.activate("../../spm/wrappers/julia/spm")
Pkg.activate("PaStiX")
using CBinding
using PaStiX
using spm

if PaStiX.pastix_mpi_enabled
    using MPI
    MPI.Init()
end

#
# Two solutions to select the outpu file to pass to output functions
#
my_stdout = Libc.FILE( Libc.RawFD(1), "w" ) # Select the stdout or stderr through 1 or 2
#my_stdout = Ptr{Cvoid}(0)                   # Give a null pointer to use the default

A    = spm.spmatrix_t(zero)
Aptr = pointer_from_objref(A)

# Load a sparse matrix from HB driver

spm.spmReadDriver( spm.SpmDriverLaplacian, "10:10:10:2.:1.", Aptr )
spm.spmPrintInfo( Aptr, my_stdout )

# Scale A for low-rank: A / ||A||_f
norm = spm.spmNorm( spm.SpmFrobeniusNorm, Aptr )
spm.spmScal( 1. / norm, Aptr )

# Generate b and x0 vector such that A * x0 = b
nrhs = 10
n    = A.nexp
X    = zeros(Cdouble, (n, nrhs))
B    = zeros(Cdouble, (n, nrhs))
X0   = zeros(Cdouble, (n, nrhs))

spm.spmGenRHS( spm.SpmRhsRndX, nrhs, Aptr, X0, n, B, n )

# Initialize parameters to default values
iparm = zeros( PaStiX.Pastix_int_t, PaStiX.iparm_size )
dparm = zeros( Cdouble, PaStiX.dparm_size )
PaStiX.pastixInitParam( iparm, dparm )

iparm[PaStiX.iparm_scheduler] = PaStiX.schedsequential #-s 0

# Startup PaStiX
#pastix_data = Ref{Ptr{Cvoid}}()
pastix_data = zeros(Int64,1)
pastix_data_ptr = pointer_from_objref(pastix_data)

PaStiX.pastixInit( pastix_data_ptr, 0, iparm, dparm )

# Perform analyze
PaStiX.pastix_task_analyze( pastix_data, Aptr )

# Perform numerical factorization
PaStiX.pastix_task_numfact( pastix_data, Aptr )

# Perform solve
X = copy(B)
PaStiX.pastix_task_solve( pastix_data, n, nrhs, X, n )

# Refine the solution
PaStiX.pastix_task_refine( pastix_data, n, nrhs, B, n, X, n )

# Check solution
eps = dparm[PaStiX.dparm_epsilon_refinement]
spm.spmCheckAxb( eps, nrhs, Aptr, X0, n, B, n, X, n )

PaStiX.pastixFinalize( pastix_data_ptr )
spm.spmExit( Aptr )

!
! @file flaplacian.F90
!
! Fortran 90 example using a laplacian matrix.
!
! @copyright 2015-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!                      Univ. Bordeaux. All rights reserved.
!
! @version 6.4.0
! @author Mathieu Faverge
! @author Alycia Lisito
! @date 2024-07-05
!
program flaplacian
  use iso_c_binding
  use spmf
  use pastixf
  implicit none

  integer(kind=spm_int_t),        dimension(:),   pointer             :: rowptr
  integer(kind=spm_int_t),        dimension(:),   pointer             :: colptr
  complex(kind=c_double_complex), dimension(:),   pointer             :: values
  complex(kind=c_double_complex), dimension(:,:), allocatable, target :: x0, x, b
  type(pastix_data_t),        pointer                                 :: pastix_data
  type(spmatrix_t),           pointer                                 :: spm
  type(spmatrix_t),           pointer                                 :: spm2
  integer(kind=pastix_int_t), target                                  :: iparm(iparm_size)
  real(kind=c_double),        target                                  :: dparm(dparm_size)
  integer(kind=pastix_int_t)                                          :: dim1, dim2, dim3, n, nnz
  integer(kind=pastix_int_t)                                          :: i, j, k, l, nrhs
  integer(c_int)                                                      :: info

  ! 1- Initialize the parameters and the solver
  ! (Done before any calls to spm to automatically intialize MPI if needed)
  call pastixInitParam( iparm, dparm )
  call pastixInit( pastix_data, MPI_COMM_WORLD, iparm, dparm )

  !
  ! Generate a 10x10x10 complex Laplacian
  !
  dim1 = 10
  dim2 = 10
  dim3 = 10
  n    = dim1 * dim2 * dim3
  nnz  = (2*(dim1)-1) * dim2 * dim3 + (dim2-1)*dim1*dim3 + dim2*dim1*(dim3-1)

  !
  ! Create the spm out of the internal data
  !
  allocate( spm )
  call spmInit( spm )
  spm%baseval = 1
  spm%mtxtype = SpmSymmetric
  spm%flttype = SpmComplex64
  spm%fmttype = SpmIJV
  spm%n       = n
  spm%nnz     = nnz
  spm%dof     = 1

  call spmUpdateComputedFields( spm )
  call spmAlloc( spm )
  call spmGetArray( spm, colptr=colptr, rowptr=rowptr, zvalues=values )

  l = 1
  do i=1,dim1
     do j=1,dim2
        do k=1,dim3
           rowptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
           colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
           values(l) = (6., 0.)

           if (i == 1) then
              values(l) = values(l) - (1., 0.)
           end if
           if (i == dim1) then
              values(l) = values(l) - (1., 0.)
           end if
           if (j == 1) then
              values(l) = values(l) - (1., 0.)
           end if
           if (j == dim2) then
              values(l) = values(l) - (1., 0.)
           end if
           if (k == 1) then
              values(l) = values(l) - (1., 0.)
           end if
           if (k == dim3) then
              values(l) = values(l) - (1., 0.)
           end if

           values(l) = values(l) * 8.
           l = l + 1

           if (i < dim1) then
              rowptr(l) =  i    + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
              colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
              values(l) = (- 1.,  - 1.)
              l = l + 1
           end if
           if (j < dim2) then
              rowptr(l) = (i-1) + dim1 *  j    + dim1 * dim2 * (k-1) + 1
              colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
              values(l) = (- 1., - 1.)
              l = l + 1
           end if
           if (k < dim3) then
              rowptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 *  k    + 1
              colptr(l) = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
              values(l) = (-1., - 1. )
              l = l + 1
           end if
        end do
     end do
  end do

  if ( l .ne. nnz+1 ) then
     write(6,*) 'l ', l, " nnz ", nnz
  end if

  allocate( spm2 )
  call spmCheckAndCorrect( spm, spm2, info )
  if ( info .ne. 0 ) then
     call spmExit( spm )
     spm = spm2
  end if
  deallocate( spm2 )

  call spmPrintInfo( spm )

  !   2- The right hand side
  nrhs = 10
  allocate(x0(spm%nexp, nrhs))
  allocate(x( spm%nexp, nrhs))
  allocate(b( spm%nexp, nrhs))

  call spmGenRHS( SpmRhsRndX, nrhs, spm, x0, spm%nexp, b, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "spmGenRHS failed"
  end if
  x = b

  !
  ! Solve the problem
  !

  ! 2- Analyze the problem
  call pastix_task_analyze( pastix_data, spm, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_analyze failed"
  end if

  ! 3- Factorize the matrix
  call pastix_task_numfact( pastix_data, spm, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_numfact failed"
  end if

  ! 4- Solve the problem
  call pastix_task_solve( pastix_data, spm%nexp, nrhs, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_solve failed"
  end if

  ! 5- Refine the solution
  call pastix_task_refine( pastix_data, spm%nexp, nrhs, b, spm%nexp, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "pastix_rask_refine failed"
  end if

  ! 6- Destroy the C data structure
  call pastixFinalize( pastix_data )

  !
  ! Check the solution
  !
  call spmCheckAxb( dparm(DPARM_EPSILON_REFINEMENT), nrhs, spm, x0, spm%nexp, b, spm%nexp, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "spmCheckAxB failed"
  end if

  call spmExit( spm )
  deallocate(spm)
  deallocate(x0)
  deallocate(x)
  deallocate(b)

end program flaplacian

#!/usr/bin/env julia
#=
  @file spm_driver.jl

  @brief SpM example to generate a sparse matrix from the spm drivers

  @copyright 2019-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                       Univ. Bordeaux. All rights reserved.

  @version 1.2.4
  @author Mathieu Faverge
  @author Selmane Lebdaoui
  @author Tony Delarue
  @date 2024-05-29

  @ingroup examples_julia
  @code

=#
using Pkg
Pkg.activate("spm")
Pkg.instantiate()
using CBinding
using spm

if spm.spm_mpi_enabled
    using MPI
    MPI.Init()
end

#
# Two solutions to select the outpu file to pass to output functions
#
my_stdout = Libc.FILE( Libc.RawFD(1), "w" ) # Select the stdout or stderr through 1 or 2
#my_stdout = Ptr{Cvoid}(0)                   # Give a null pointer to use the default

A    = spm.spmatrix_t(zero)
Aptr = Ptr{spm.spmatrix_t}(pointer_from_objref(A))

# Example from a HB file
#spm.spmReadDriver( spm.SpmDriverHB, "__SPM_DIR__/tests/matrix/orsirr.rua", Aptr )

# Example from the Laplacian generator driver
spm.spmReadDriver( spm.SpmDriverLaplacian, "10:10:10:2.:1.", Aptr )

spm.spmPrintInfo( Aptr, my_stdout )

# Scale A for low-rank: A / ||A||_f
norm = spm.spmNorm( spm.SpmFrobeniusNorm, Aptr )
spm.spmScal( 1. / norm, Aptr )

# Generate b and x0 vectors such that A * x0 = b

nrhs = 10
n    = A.nexp
X0   = zeros( Cdouble, (n, nrhs) )
B    = zeros( Cdouble, (n, nrhs) )
X    = zeros( Cdouble, (n, nrhs) )

spm.spmGenRHS( spm.SpmRhsRndX, nrhs, Aptr, X, n, B, n )

# Copy x0 into x for backup
X0 = copy(X)

# Check that A * x = b
eps = 1.e-15 # Set to 1e-7 for single precision
spm.spmCheckAxb( eps, nrhs, Aptr, X0, n, B, n, X, n )

spm.spmExit( Aptr )

#=
  @endcode
=#

#=

 @file pastix_enums.jl

 PaStiX julia wrapper to define enums and datatypes

 @copyright 2020-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                      Univ. Bordeaux. All rights reserved.

 @version 6.4.0
 @author Mathieu Faverge
 @author Selmane Lebdaoui
 @author Tony Delarue
 @date 2024-06-08

 This file has been automatically generated with gen_wrappers.py

 @ingroup wrap_julia

=#

Pastix_int_t = Int32
pastix_mpi_enabled = true
const Pastix_data_t = Cvoid
const Pastix_rhs_t = Ptr{Cvoid}
const Pastix_graph_t = Ptr{Cvoid}

using spm
if pastix_mpi_enabled
    using MPI
end

function __get_mpi_type__()
    if !pastix_mpi_enabled
        return Cint
    elseif sizeof(MPI.MPI_Comm) == sizeof(Clong)
        return Clong
    elseif sizeof(MPI.MPI_Comm) == sizeof(Cint)
        return Cint
    end
    return Cvoid
end

@cenum Pastix_iparm_t {
    iparm_verbose                        = 1,
    iparm_io_strategy                    = 2,
    iparm_nnzeros                        = 3,
    iparm_nnzeros_block_local            = 4,
    iparm_allocated_terms                = 5,
    iparm_produce_stats                  = 6,
    iparm_trace                          = 7,
    iparm_mc64                           = 8,
    iparm_ordering                       = 9,
    iparm_ordering_default               = 10,
    iparm_scotch_mt                      = 11,
    iparm_scotch_switch_level            = 12,
    iparm_scotch_cmin                    = 13,
    iparm_scotch_cmax                    = 14,
    iparm_scotch_frat                    = 15,
    iparm_metis_ctype                    = 16,
    iparm_metis_rtype                    = 17,
    iparm_metis_no2hop                   = 18,
    iparm_metis_nseps                    = 19,
    iparm_metis_niter                    = 20,
    iparm_metis_ufactor                  = 21,
    iparm_metis_compress                 = 22,
    iparm_metis_ccorder                  = 23,
    iparm_metis_pfactor                  = 24,
    iparm_metis_seed                     = 25,
    iparm_metis_dbglvl                   = 26,
    iparm_amalgamation_lvlblas           = 27,
    iparm_amalgamation_lvlcblk           = 28,
    iparm_reordering_split               = 29,
    iparm_reordering_stop                = 30,
    iparm_splitting_strategy             = 31,
    iparm_splitting_levels_projections   = 32,
    iparm_splitting_levels_kway          = 33,
    iparm_splitting_projections_depth    = 34,
    iparm_splitting_projections_distance = 35,
    iparm_splitting_projections_width    = 36,
    iparm_min_blocksize                  = 37,
    iparm_max_blocksize                  = 38,
    iparm_tasks2d_level                  = 39,
    iparm_tasks2d_width                  = 40,
    iparm_allcand                        = 41,
    iparm_incomplete                     = 42,
    iparm_level_of_fill                  = 43,
    iparm_factorization                  = 44,
    iparm_facto_look_side                = 45,
    iparm_static_pivoting                = 46,
    iparm_free_cscuser                   = 47,
    iparm_schur_fact_mode                = 48,
    iparm_transpose_solve                = 49,
    iparm_schur_solv_mode                = 50,
    iparm_applyperm_ws                   = 51,
    iparm_refinement                     = 52,
    iparm_nbiter                         = 53,
    iparm_itermax                        = 54,
    iparm_gmres_im                       = 55,
    iparm_scheduler                      = 56,
    iparm_thread_nbr                     = 57,
    iparm_socket_nbr                     = 58,
    iparm_autosplit_comm                 = 59,
    iparm_gpu_nbr                        = 60,
    iparm_gpu_memory_percentage          = 61,
    iparm_gpu_memory_block_size          = 62,
    iparm_global_allocation              = 63,
    iparm_compress_min_width             = 64,
    iparm_compress_min_height            = 65,
    iparm_compress_when                  = 66,
    iparm_compress_method                = 67,
    iparm_compress_ortho                 = 68,
    iparm_compress_reltol                = 69,
    iparm_compress_preselect             = 70,
    iparm_compress_iluk                  = 71,
    iparm_mixed                          = 72,
    iparm_ftz                            = 73,
    iparm_mpi_thread_level               = 74,
    iparm_modify_parameter               = 75,
    iparm_start_task                     = 76,
    iparm_end_task                       = 77,
    iparm_float                          = 78,
    iparm_mtx_type                       = 79,
    iparm_dof_nbr                        = 80,
    iparm_size                           = 80,
}

@cenum Pastix_dparm_t {
    dparm_fill_in            = 1,
    dparm_epsilon_refinement = 2,
    dparm_relative_error     = 3,
    dparm_epsilon_magn_ctrl  = 4,
    dparm_order_time         = 5,
    dparm_symbfact_time      = 6,
    dparm_reorder_time       = 7,
    dparm_blend_time         = 8,
    dparm_analyze_time       = 9,
    dparm_pred_fact_time     = 10,
    dparm_fact_time          = 11,
    dparm_fact_flops         = 12,
    dparm_fact_thflops       = 13,
    dparm_fact_rlflops       = 14,
    dparm_fact_energy        = 15,
    dparm_mem_fr             = 16,
    dparm_mem_lr             = 17,
    dparm_solv_time          = 18,
    dparm_solv_flops         = 19,
    dparm_solv_thflops       = 20,
    dparm_solv_rlflops       = 21,
    dparm_solv_energy        = 22,
    dparm_refine_time        = 23,
    dparm_a_norm             = 24,
    dparm_compress_tolerance = 25,
    dparm_compress_min_ratio = 26,
    dparm_size               = 26,
}

@cenum Pastix_task_t {
    taskinit     = 0,
    taskordering = 1,
    tasksymbfact = 2,
    taskanalyze  = 3,
    tasknumfact  = 4,
    tasksolve    = 5,
    taskrefine   = 6,
    taskclean    = 7,
}

@cenum Pastix_trace_t {
    tracenot          = 0,
    tracenumfact      = 16,
    tracesolve        = 32,
    tracefactandsolve = 48,
}

@cenum Pastix_verbose_t {
    verbosenot = 0,
    verboseno  = 1,
    verboseyes = 2,
}

@cenum Pastix_io_t {
    iono        = 0,
    ioload      = 1,
    iosave      = 2,
    ioloadgraph = 4,
    iosavegraph = 8,
    ioloadcsc   = 16,
    iosavecsc   = 32,
}

@cenum Pastix_fact_mode_t {
    factmodelocal = 0,
    factmodeschur = 1,
    factmodeboth  = 2,
}

@cenum Pastix_solv_mode_t {
    solvmodelocal     = 0,
    solvmodeinterface = 1,
    solvmodeschur     = 2,
}

@cenum Pastix_refine_t {
    refinegmres    = 0,
    refinecg       = 1,
    refinesr       = 2,
    refinebicgstab = 3,
}

@cenum Pastix_factotype_t {
    factpotrf = 0,
    factsytrf = 1,
    factgetrf = 2,
    factpxtrf = 3,
    facthetrf = 4,
    factllh   = 0,
    factldlt  = 1,
    factlu    = 2,
    factllt   = 3,
    factldlh  = 4,
}

@cenum Pastix_factolookside_t {
    factleftlooking  = 0,
    factrightlooking = 1,
}

@cenum Pastix_scheduler_t {
    schedsequential = 0,
    schedstatic     = 1,
    schedparsec     = 2,
    schedstarpu     = 3,
    scheddynamic    = 4,
}

@cenum Pastix_ordering_t {
    orderscotch   = 0,
    ordermetis    = 1,
    orderpersonal = 2,
    orderptscotch = 3,
    orderparmetis = 4,
}

@cenum Pastix_mpithreadmode_t {
    mpinone             = 0,
    mpithreadsingle     = 1,
    mpithreadfunneled   = 2,
    mpithreadserialized = 3,
    mpithreadmultiple   = 4,
}

@cenum Pastix_error_t {
    success            = 0,
    err_unknown        = 1,
    err_alloc          = 2,
    err_notimplemented = 3,
    err_outofmemory    = 4,
    err_thread         = 5,
    err_internal       = 6,
    err_badparameter   = 7,
    err_file           = 8,
    err_integer_type   = 9,
    err_io             = 10,
    err_mpi            = 11,
}

@cenum Pastix_compress_when_t {
    compressnever      = 0,
    compresswhenbegin  = 1,
    compresswhenend    = 2,
    compresswhenduring = 3,
}

@cenum Pastix_compress_method_t {
    compressmethodsvd   = 0,
    compressmethodpqrcp = 1,
    compressmethodrqrcp = 2,
    compressmethodtqrcp = 3,
    compressmethodrqrrt = 4,
    compressmethodnbr   = 5,
}

@cenum Pastix_compress_ortho_t {
    compressorthocgs       = 0,
    compressorthoqr        = 1,
    compressorthopartialqr = 2,
}

@cenum Pastix_split_t {
    splitnot             = 0,
    splitkway            = 1,
    splitkwayprojections = 2,
}

@cenum Pastix_layout_t {
    rowmajor = 101,
    colmajor = 102,
}

@cenum Pastix_trans_t {
    notrans   = 111,
    trans     = 112,
    conjtrans = 113,
}

@cenum Pastix_uplo_t {
    upper      = 121,
    lower      = 122,
    upperlower = 123,
}

@cenum Pastix_coefside_t {
    lcoef  = 0,
    ucoef  = 1,
    lucoef = 2,
}

@cenum Pastix_diag_t {
    nonunit = 131,
    unit    = 132,
}

@cenum Pastix_side_t {
    left  = 141,
    right = 142,
}

@cenum Pastix_normtype_t {
    onenorm       = 171,
    frobeniusnorm = 174,
    infnorm       = 175,
    maxnorm       = 177,
}

@cenum Pastix_dir_t {
    dirforward  = 391,
    dirbackward = 392,
}

@cenum Pastix_mtxtype_t {
    general   = notrans,
    symmetric = trans,
    hermitian = conjtrans,
}

@cstruct Pastix_order_t {
    baseval::Pastix_int_t
    vertnbr::Pastix_int_t
    cblknbr::Pastix_int_t
    permtab::Ptr{Pastix_int_t}
    peritab::Ptr{Pastix_int_t}
    rangtab::Ptr{Pastix_int_t}
    treetab::Ptr{Pastix_int_t}
    selevtx::Ptr{Int8}
    sndenbr::Pastix_int_t
    sndetab::Ptr{Pastix_int_t}
    peritab_exp::Ptr{Pastix_int_t}
}

!
! @file fmultidof.F90
!
! Fortran 90 example using a matrix read with the spm driver.
!
! @copyright 2017-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
!                      Univ. Bordeaux. All rights reserved.
!
! @version 6.4.0
! @author Mathieu Faverge
! @author Alycia Lisito
! @date 2024-07-05
!
program fmultidof
  use iso_c_binding
  use spmf
  use pastixf

  implicit none

  type(pastix_data_t),        pointer                      :: pastix_data
  type(pastix_order_t),       pointer                      :: order => null()
  type(spmatrix_t),           pointer                      :: spm
  !type(spmatrix_t),           pointer                      :: spm2
  integer(kind=pastix_int_t), target                       :: iparm(iparm_size)
  real(kind=c_double),        target                       :: dparm(dparm_size)
  real(kind=c_double)                                      :: normA
  integer(c_int)                                           :: info
  integer(kind=pastix_int_t)                               :: nrhs
  real(kind=c_double), dimension(:,:), allocatable, target :: x0, x, b

  ! 1- Initialize the parameters and the solver
  call pastixInitParam( iparm, dparm )
  call pastixInit( pastix_data, MPI_COMM_WORLD, iparm, dparm )

  !
  ! Initialize the problem
  !   1- The matrix
  ! See genLaplacian function for the parameters
  ! Here we generate a 10x101x0 laplacian with 5 degrees of freedom per unknown
  !
  allocate( spm )
  call spmReadDriver( SpmDriverLaplacian, "d:10:10:10:4.:.5:5", spm, info )
  if ( info .ne. 0 ) then
     error stop "spmReadDriver failed"
  end if

  !
  ! We do not check the matrix as it would expand the spm matrix, and
  ! the compressed version would not be used. If you reuse this
  ! testing, you have to make sure that the compressed form of the
  ! matrix is correct without calling the spmCheckAndCorrect. One way
  ! to do it, is to call the function on the matrix without the values
  ! to make sure its correct.
  !
  ! allocate( spm2 )
  ! call spmCheckAndCorrect( spm, spm2, info )
  ! if ( info .ne. 0 ) then
  !    call spmExit( spm )
  !    spm = spm2
  ! end if
  ! deallocate( spm2 )

  ! Print information about the matrix
  call spmPrintInfo( spm )

  ! Scale A for better stability with low-rank computations
  call spmNorm( SpmFrobeniusNorm, spm, normA )
  call spmScal( 1. / normA, spm )

  !
  ! Solve the problem
  !

  ! 2- Analyze the problem
  !   a- Split the analyze in substeps. The first three steps handle
  !      multi-dof spm, the last one does not yet
  call pastix_subtask_order( pastix_data, spm, order, info );
  if ( info .ne. 0 ) then
     error stop "pastix_subtask_order failed"
  end if

  call pastix_subtask_symbfact( pastix_data, info );
  if ( info .ne. 0 ) then
     error stop "pastix_subtask_symbfact failed"
  end if

  call pastix_subtask_reordering( pastix_data, info );
  if ( info .ne. 0 ) then
     error stop "pastix_subtask_reordering failed"
  end if

  !   b- Expand the matrix and the associated substructure
  call pastixExpand( pastix_data, spm )

  !   c- Finish the analyze step
  call pastix_subtask_blend( pastix_data, info )
  if ( info .ne. 0 ) then
     error stop "pastix_subtask_blend failed"
  end if

  ! 3- Factorize the matrix
  call pastix_task_numfact( pastix_data, spm, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_numfact failed"
  end if

  !
  ! We need to generate the right hand side once the spm has been
  ! expanded, spmGenRHS is not yet compatible with multi-dof
  !
  nrhs = 10
  allocate(x0(spm%nexp, nrhs))
  allocate(x( spm%nexp, nrhs))
  allocate(b( spm%nexp, nrhs))

  call spmGenRHS( SpmRhsRndX, nrhs, spm, x0, spm%nexp, b, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "spmGenRHS failed"
  end if
  x = b

  ! 4- Solve the problem
  call pastix_task_solve( pastix_data, spm%nexp, nrhs, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_solve failed"
  end if

  ! 5- Refine the solution
  call pastix_task_refine( pastix_data, spm%nexp, nrhs, b, spm%nexp, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "pastix_task_refine failed"
  end if

  ! 6- Destroy the C data structure
  call pastixFinalize( pastix_data )

  !
  ! Check the solution
  !
  call spmCheckAxb( dparm(DPARM_EPSILON_REFINEMENT), nrhs, spm, x0, spm%nexp, b, spm%nexp, x, spm%nexp, info )
  if ( info .ne. 0 ) then
     error stop "spmCheckAxb failed"
  end if

  call spmExit( spm )
  deallocate(spm)
  deallocate(x0)
  deallocate(x)
  deallocate(b)

end program fmultidof

#!/usr/bin/env julia
#=
  @file spm_user.jl

  @brief Julia SpM example using a laplacian matrix.

  @copyright 2019-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                       Univ. Bordeaux. All rights reserved.

  @version 1.2.4
  @author Mathieu Faverge
  @author Selmane Lebdaoui
  @author Tony Delarue
  @date 2024-05-29

  @ingroup examples_julia
  @code

=#
using Pkg
Pkg.activate("spm")
Pkg.instantiate()
using CBinding
using spm

using Base
using Distributed

if spm.spm_mpi_enabled
    using MPI
    MPI.Init()
end

A    = spm.spmatrix_t(zero)
Aptr = pointer_from_objref(A)

#
# Two solutions to select the outpu file to pass to output functions
#
my_stdout = Libc.FILE( Libc.RawFD(1), "w" ) # Select the stdout or stderr through 1 or 2
#my_stdout = Ptr{Cvoid}(0)                   # Give a null pointer to use the default

#
#Generate a 10x10x10 complex Laplacian in IJV format
#
dim1 = 10
dim2 = 10
dim3 = 10
n    = dim1 * dim2 * dim3
nnz  = (2*(dim1)-1) * dim2 * dim3 + (dim2-1)*dim1*dim3 + dim2*dim1*(dim3-1)

#Create the spm out of the internal data
spm.spmInit( Aptr )
A.baseval = 1
A.mtxtype = spm.SpmSymmetric
A.flttype = spm.SpmDouble
A.fmttype = spm.SpmIJV
A.n       = n
A.nnz     = nnz
A.dof     = 1

spm.spmUpdateComputedFields( Aptr )

# Allocate the arrays of the spm through C functions
spm.spmAlloc( Aptr )

# Get the pointer to the allocated arrays
row = unsafe_wrap(Array, A.rowptr, A.nnzexp, own = false)
col = unsafe_wrap(Array, A.colptr, A.nnzexp, own = false)
val = unsafe_wrap(Array{Cdouble,1}, convert( Ptr{Cdouble}, A.values ), A.nnzexp, own = false)

m = 1
for i in 1:dim1
    for j in 1:dim2
        for k in 1:dim3
            global m
            row[m] = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
            col[m] = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
            val[m] = 6.
            if i == 1
                val[m] = val[m] - 1.
            end
            if i == dim1
                val[m] = val[m] - 1.
            end
            if j == 1
                val[m] = val[m] - 1.
            end
            if j == dim2
                val[m] = val[m] - 1.
            end
            if k == 1
                val[m] = val[m] - 1.
            end
            if k == dim3
                val[m] = val[m] - 1.
            end
            val[m] = val[m] * 8.
            m = m + 1
            if i < dim1
                row[m] =  i    + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
                col[m] = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
                val[m] = - 1.
                m = m + 1
            end
            if j < dim2
                row[m] = (i-1) + dim1 *  j    + dim1 * dim2 * (k-1) + 1
                col[m] = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
                val[m] = - 1.
                m = m + 1
            end
            if k < dim3
                row[m] = (i-1) + dim1 * (j-1) + dim1 * dim2 *  k    + 1
                col[m] = (i-1) + dim1 * (j-1) + dim1 * dim2 * (k-1) + 1
                val[m] = -1.
                m = m + 1
            end
        end
    end
end

if m != nnz+1
    println( "m ", m, "nnz ", nnz )
end

A2 = spm.spmatrix_t( zero )
A2ptr = Ptr{spm.spmatrix_t}( pointer_from_objref(A2) )
rc = spm.spmCheckAndCorrect( Aptr, A2ptr )

if rc != 0
     spm.spmExit( Aptr )
     clear!( :A )
     clear!( :Aptr )
     A = A2
     Aptr = A2ptr
end

spm.spmPrintInfo( Aptr, my_stdout )

# 2- The right hand side

nrhs = 10
x0   = zeros( Cdouble, ( A.nexp, nrhs ) )
b    = zeros( Cdouble, ( A.nexp, nrhs ) )
x    = zeros( Cdouble, ( A.nexp, nrhs ) )

spm.spmGenRHS( spm.SpmRhsRndX, nrhs, Aptr, x0, n, b, n )

# Copy x0 into x for backup
x = x0

# Check that A * x = b
eps = 1.e-15 # Set to 1e-7 for single precision
spm.spmCheckAxb( eps, nrhs, Aptr, x, n, b, n, x0, n )

spm.spmExit( Aptr )

clear!( :A )
clear!( :Aptr )
clear!( :b )
clear!( :x )
clear!( :x0 )

#=
  @endcode
=#

#=

 @file spm.jl

 SPM julia wrapper

 @copyright 2020-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                      Univ. Bordeaux. All rights reserved.

 @version 1.2.4
 @author Mathieu Faverge
 @author Selmane Lebdaoui
 @author Tony Delarue
 @date 2024-06-27

 This file has been automatically generated with gen_wrappers.py

 @ingroup wrap_julia

=#

module spm
using CBinding
using Libdl
include("spm_enums.jl")

function spm_library_path()
    x = Libdl.dlext
    return "libspm.$x"
end
libspm = spm_library_path()

@cbindings libspm begin
    @cextern spmInit( spm::Ptr{spmatrix_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmInitDist( spm::Ptr{spmatrix_t}, comm::__get_mpi_type__() )::Cvoid
end

@cbindings libspm begin
    @cextern spmAlloc( spm::Ptr{spmatrix_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmExit( spm::Ptr{spmatrix_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmCopy( spm_in::Ptr{spmatrix_t}, spm_out::Ptr{spmatrix_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmBase( spm::Ptr{spmatrix_t}, baseval::Cint )::Cvoid
end

@cbindings libspm begin
    @cextern spmFindBase( spm::Ptr{spmatrix_t} )::spm_int_t
end

@cbindings libspm begin
    @cextern spmGetDegree( spm::Ptr{spmatrix_t} )::spm_int_t
end

@cbindings libspm begin
    @cextern spmConvert( ofmttype::Cint, ospm::Ptr{spmatrix_t} )::Cint
end

@cbindings libspm begin
    @cextern spmUpdateComputedFields( spm::Ptr{spmatrix_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmGenFakeValues( spm::Ptr{spmatrix_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmScatter( spm_scattered::Ptr{spmatrix_t}, root::Cint, opt_spm_gathered::Ptr{spmatrix_t}, opt_n::spm_int_t, opt_loc2glob::Ptr{spm_int_t}, opt_distByColumn::Cint, opt_comm::__get_mpi_type__() )::Cint
end

@cbindings libspm begin
    @cextern spmGather( spm_scattered::Ptr{spmatrix_t}, root::Cint, opt_spm_gathered::Ptr{spmatrix_t} )::Cint
end

@cbindings libspm begin
    @cextern spmGatherInPlace( spm::Ptr{spmatrix_t} )::Cint
end

@cbindings libspm begin
    @cextern spmRedistribute( spm::Ptr{spmatrix_t}, new_n::spm_int_t, newl2g::Ptr{spm_int_t}, newspm::Ptr{spmatrix_t} )::Cint
end

@cbindings libspm begin
    @cextern spmNorm( ntype::spm_normtype_t, spm::Ptr{spmatrix_t} )::Cdouble
end

@cbindings libspm begin
    @cextern spmNormVec( ntype::spm_normtype_t, spm::Ptr{spmatrix_t}, x::Ptr{Cvoid}, incx::spm_int_t )::Cdouble
end

@cbindings libspm begin
    @cextern spmNormMat( ntype::spm_normtype_t, spm::Ptr{spmatrix_t}, n::spm_int_t, A::Ptr{Cvoid}, lda::spm_int_t )::Cdouble
end

@cbindings libspm begin
    @cextern spmMatVec( trans::spm_trans_t, alpha::Cdouble, spm::Ptr{spmatrix_t}, x::Ptr{Cvoid}, beta::Cdouble, y::Ptr{Cvoid} )::Cint
end

@cbindings libspm begin
    @cextern spmMatMat( trans::spm_trans_t, n::spm_int_t, alpha::Cdouble, A::Ptr{spmatrix_t}, B::Ptr{Cvoid}, ldb::spm_int_t, beta::Cdouble, C::Ptr{Cvoid}, ldc::spm_int_t )::Cint
end

@cbindings libspm begin
    @cextern spmScal( alpha::Cdouble, spm::Ptr{spmatrix_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmScalVec( alpha::Cdouble, spm::Ptr{spmatrix_t}, x::Ptr{Cvoid}, incx::spm_int_t )::Cvoid
end

@cbindings libspm begin
    @cextern spmScalMat( alpha::Cdouble, spm::Ptr{spmatrix_t}, n::spm_int_t, A::Ptr{Cvoid}, lda::spm_int_t )::Cvoid
end

@cbindings libspm begin
    @cextern spmSort( spm::Ptr{spmatrix_t} )::Cint
end

@cbindings libspm begin
    @cextern spmMergeDuplicate( spm::Ptr{spmatrix_t} )::spm_int_t
end

@cbindings libspm begin
    @cextern spmSymmetrize( spm::Ptr{spmatrix_t} )::spm_int_t
end

@cbindings libspm begin
    @cextern spmCheckAndCorrect( spm_in::Ptr{spmatrix_t}, spm_out::Ptr{spmatrix_t} )::Cint
end

@cbindings libspm begin
    @cextern spmGenMat( type::spm_rhstype_t, nrhs::spm_int_t, spm::Ptr{spmatrix_t}, alpha::Ptr{Cvoid}, seed::Culonglong, A::Ptr{Cvoid}, lda::spm_int_t )::Cint
end

@cbindings libspm begin
    @cextern spmGenVec( type::spm_rhstype_t, spm::Ptr{spmatrix_t}, alpha::Ptr{Cvoid}, seed::Culonglong, x::Ptr{Cvoid}, incx::spm_int_t )::Cint
end

@cbindings libspm begin
    @cextern spmGenRHS( type::spm_rhstype_t, nrhs::spm_int_t, spm::Ptr{spmatrix_t}, opt_X::Ptr{Cvoid}, opt_ldx::spm_int_t, B::Ptr{Cvoid}, ldb::spm_int_t )::Cint
end

@cbindings libspm begin
    @cextern spmCheckAxb( eps::Cdouble, nrhs::spm_int_t, spm::Ptr{spmatrix_t}, opt_X0::Ptr{Cvoid}, opt_ldx0::spm_int_t, B::Ptr{Cvoid}, ldb::spm_int_t, X::Ptr{Cvoid}, ldx::spm_int_t )::Cint
end

@cbindings libspm begin
    @cextern spmExtractLocalRHS( nrhs::spm_int_t, spm::Ptr{spmatrix_t}, Bg::Ptr{Cvoid}, ldbg::spm_int_t, Bl::Ptr{Cvoid}, ldbl::spm_int_t )::Cint
end

@cbindings libspm begin
    @cextern spmReduceRHS( nrhs::spm_int_t, spm::Ptr{spmatrix_t}, Bg::Ptr{Cvoid}, ldbg::spm_int_t, Bl::Ptr{Cvoid}, ldbl::spm_int_t )::Cint
end

@cbindings libspm begin
    @cextern spmGatherRHS( nrhs::spm_int_t, spm::Ptr{spmatrix_t}, Bl::Ptr{Cvoid}, ldbl::spm_int_t, root::Cint, Bg::Ptr{Cvoid}, ldbg::spm_int_t )::Cint
end

@cbindings libspm begin
    @cextern spmIntConvert( n::spm_int_t, input::Ptr{Cint}, output::Ptr{spm_int_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmLoadDist( spm::Ptr{spmatrix_t}, filename::Cstring, comm::__get_mpi_type__() )::Cint
end

@cbindings libspm begin
    @cextern spmLoad( spm::Ptr{spmatrix_t}, filename::Cstring )::Cint
end

@cbindings libspm begin
    @cextern spmSave( spm::Ptr{spmatrix_t}, filename::Cstring )::Cint
end

@cbindings libspm begin
    @cextern spmReadDriver( driver::spm_driver_t, filename::Cstring, spm::Ptr{spmatrix_t} )::Cint
end

@cbindings libspm begin
    @cextern spmReadDriverDist( driver::spm_driver_t, filename::Cstring, spm::Ptr{spmatrix_t}, comm::__get_mpi_type__() )::Cint
end

@cbindings libspm begin
    @cextern spmParseLaplacianInfo( filename::Cstring, flttype::Ptr{spm_coeftype_t}, dim1::Ptr{spm_int_t}, dim2::Ptr{spm_int_t}, dim3::Ptr{spm_int_t}, alpha::Ptr{Cdouble}, beta::Ptr{Cdouble}, dof::Ptr{spm_int_t} )::Cint
end

@cbindings libspm begin
    @cextern spm2Dense( spm::Ptr{spmatrix_t}, A::Ptr{Cvoid} )::Cvoid
end

@cbindings libspm begin
    @cextern spmPrint( spm::Ptr{spmatrix_t}, f::Ptr{Cvoid} )::Cvoid
end

@cbindings libspm begin
    @cextern spmPrintRHS( spm::Ptr{spmatrix_t}, nrhs::Cint, x::Ptr{Cvoid}, ldx::spm_int_t, stream::Ptr{Cvoid} )::Cvoid
end

@cbindings libspm begin
    @cextern spmPrintInfo( spm::Ptr{spmatrix_t}, f::Ptr{Cvoid} )::Cvoid
end

@cbindings libspm begin
    @cextern spmExpand( spm_in::Ptr{spmatrix_t}, spm_out::Ptr{spmatrix_t} )::Cvoid
end

@cbindings libspm begin
    @cextern spmDofExtend( spm::Ptr{spmatrix_t}, type::Cint, dof::Cint, spm_out::Ptr{spmatrix_t} )::Cint
end

@cbindings libspm begin
    @cextern spmBlasGetNumThreads(  )::Cint
end

@cbindings libspm begin
    @cextern spmBlasSetNumThreads( nt::Cint )::Cint
end

@cbindings libspm begin
    @cextern spmBlasSetNumThreadsOne(  )::Cint
end

end #module

#!/usr/bin/env julia
#=
 @file examples/schur.jl

 PaStiX Schur example

 @copyright 2019-2024 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
                      Univ. Bordeaux. All rights reserved.

 @version 6.4.0
 @author Mathieu Faverge
 @author Selmane Lebdaoui
 @date 2024-07-05
=#

using Pkg
Pkg.activate("../../spm/wrappers/julia/spm")
Pkg.activate("PaStiX")
using CBinding
using PaStiX
using spm
using LinearAlgebra

if PaStiX.pastix_mpi_enabled
    using MPI
    MPI.Init()
end

#
# Two solutions to select the outpu file to pass to output functions
#
my_stdout = Libc.FILE( Libc.RawFD(1), "w" ) # Select the stdout or stderr through 1 or 2
#my_stdout = Ptr{Cvoid}(0)                   # Give a null pointer to use the default

# Load a sparse matrix from RSA driver
A    = spm.spmatrix_t(zero)
Aptr = pointer_from_objref(A)

spm.spmReadDriver( spm.SpmDriverLaplacian, "10:10:10:2.:1.", Aptr )

# Generate b and x0 vector such that A * x0 = b
nrhs = 1
n    = A.gN # Let's consider a matrix with single dof such that n == nexp, and gN == gNexp
X    = zeros(Cdouble, (n, nrhs))
B    = zeros(Cdouble, (n, nrhs))
X0   = zeros(Cdouble, (n, nrhs))

spm.spmGenRHS( spm.SpmRhsRndX, nrhs, Aptr, X0, n, B, n )
X = copy(B)

spm.spmPrintInfo( Aptr, my_stdout )

# Initialize parameters to default values
iparm = zeros( PaStiX.Pastix_int_t, PaStiX.iparm_size )
dparm = zeros( Cdouble, PaStiX.dparm_size )
PaStiX.pastixInitParam( iparm, dparm )

# Startup PaStiX
pastix_data = zeros(Int64,1)
pastix_data_ptr = pointer_from_objref(pastix_data)
PaStiX.pastixInit( pastix_data_ptr, Cint(0), iparm, dparm )

factotype = PaStiX.factlu
iparm[PaStiX.iparm_factorization]   = factotype
iparm[PaStiX.iparm_scheduler]       = PaStiX.schedsequential
iparm[PaStiX.iparm_schur_solv_mode] = PaStiX.solvmodeinterface

# Initialize the Schur list as the first third of the elements
Abase = spm.spmFindBase(Aptr)
nschur = min( Int(floor( n / 3 )), 5000 )

schurlist = PaStiX.Pastix_int_t[ (i + Abase - 1) for i in 1:nschur ] # -1 cause of (1:nschur) = [[ 1, nschur ]]
PaStiX.pastixSetSchurUnknownList( pastix_data, nschur, schurlist )

# Perform analyze
PaStiX.pastix_task_analyze( pastix_data, Aptr )

# Perform numerical factorization
PaStiX.pastix_task_numfact( pastix_data, Aptr )

# Get the Schur complement
S  = zeros( Float64, nschur, nschur ) #column major !! by default in julia
rc = PaStiX.pastixGetSchur( pastix_data, S, nschur )

@assert(rc == 0)

# Store both sides for linalg
if factotype != PaStiX.factlu
    S += LinearAlgebra.transpose(LinearAlgebra.tril(S,-1))
end

# Permuted vector pointer
Xp = zeros(Int64,1)
Xp_ptr = pointer_from_objref(Xp)
PaStiX.pastixRhsInit( Xp_ptr )

# 1- Apply P to b
PaStiX.pastix_subtask_applyorder( pastix_data, spm.SpmDirForward,
                                  n, nrhs, X, n, Xp )

if factotype == PaStiX.factlu
    # 2- Forward solve on the non Schur complement part of the system
    PaStiX.pastix_subtask_trsm( pastix_data, PaStiX.left, PaStiX.lower,
                                PaStiX.notrans, PaStiX.unit, Xp )

    schur_Xp = zeros(Cdouble, (nschur, nrhs))
    PaStiX.pastixRhsSchurGet( pastix_data, nschur, nrhs, Xp, schur_Xp, nschur )

    # 3- Solve the Schur complement part
    schur_Xp = S \ schur_Xp

    PaStiX.pastixRhsSchurSet( pastix_data, nschur, nrhs, schur_Xp, nschur, Xp )

    # 4- Backward solve on the non Schur complement part of the system
    PaStiX.pastix_subtask_trsm( pastix_data, PaStiX.left, PaStiX.upper,
                                PaStiX.notrans,  PaStiX.nonunit, Xp )
else
    # 2- Forward solve on the non Schur complement part of the system
    PaStiX.pastix_subtask_trsm( pastix_data, PaStiX.left, PaStiX.lower,
                                PaStiX.notrans, PaStiX.nonunit, Xp )

    schur_Xp = zeros(Cdouble, (nschur, nrhs))
    PaStiX.pastixRhsSchurGet( pastix_data, nschur, nrhs, Xp, schur_Xp, nschur )

    # 3- Solve the Schur complement part
    LinearAlgebra.LAPACK.posv!( 'L', S, schur_Xp )

    PaStiX.pastixRhsSchurSet( pastix_data, nschur, nrhs, schur_Xp, nschur, Xp )

    # 4- Backward solve on the non Schur complement part of the system
    PaStiX.pastix_subtask_trsm( pastix_data, PaStiX.left, PaStiX.lower,
                                PaStiX.conjtrans,  PaStiX.nonunit, Xp )

end

# 5- Apply P^t to x
PaStiX.pastix_subtask_applyorder( pastix_data, spm.SpmDirBackward, n, nrhs, X, n, Xp )
PaStiX.pastixRhsFinalize( Xp )

# Check solution
eps = dparm[PaStiX.dparm_epsilon_refinement]
spm.spmCheckAxb( 1.0e-15, nrhs, Aptr, X0, n, B, n, X, n )

PaStiX.pastixFinalize( pastix_data_ptr )
spm.spmExit( Aptr )
